/* Copyright (c) 2004, 2019, Oracle and/or its affiliates. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License, version 2.0,
   as published by the Free Software Foundation.

   This program is also distributed with certain software (including
   but not limited to OpenSSL) that is licensed under separate terms,
   as designated in a particular file or component or in included license
   documentation.  The authors of MySQL hereby grant you an additional
   permission to link the program and your derivative works with the
   separately licensed software that they have included with MySQL.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License, version 2.0, for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA */
/*
  Do not edit this file, it is automatically generated from:
  <mysql_fix_privilege_tables.sql>
*/
const char* mysql_fix_privilege_tables[]={
"set @have_innodb= (select count(engine) from information_schema.engines where engine='INNODB' and support != 'NO');\n",
"set @is_mysql_encrypted = (select ENCRYPTION from information_schema.INNODB_TABLESPACES where NAME='mysql');\n",
"SET FOREIGN_KEY_CHECKS= 1;\n",
"set default_storage_engine=InnoDB;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS db\n"
  "(\n"
  "Host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL,\n"
  "Db char(64) binary DEFAULT '' NOT NULL,\n"
  "User char(32) binary DEFAULT '' NOT NULL,\n"
  "Select_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Insert_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Update_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Delete_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Create_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Drop_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Grant_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "References_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Index_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Alter_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Create_tmp_table_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Lock_tables_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Create_view_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Show_view_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Create_routine_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Alter_routine_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Execute_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Event_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Trigger_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "PRIMARY KEY Host (Host,Db,User), KEY User (User)\n"
  ")\n"
  "engine=InnoDB STATS_PERSISTENT=0 CHARACTER SET utf8 COLLATE utf8_bin comment='Database privileges' ROW_FORMAT=DYNAMIC"
  " TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"set @had_db_table= @@warning_count != 0;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS user\n"
  "(\n"
  "Host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL,\n"
  "User char(32) binary DEFAULT '' NOT NULL,\n"
  "Select_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Insert_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Update_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Delete_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Create_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Drop_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Reload_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Shutdown_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Process_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "File_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Grant_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "References_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Index_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Alter_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Show_db_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Super_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Create_tmp_table_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Lock_tables_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Execute_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Repl_slave_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Repl_client_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Create_view_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Show_view_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Create_routine_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Alter_routine_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Create_user_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Event_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Trigger_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Create_tablespace_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "ssl_type enum('','ANY','X509', 'SPECIFIED') COLLATE utf8_general_ci DEFAULT '' NOT NULL,\n"
  "ssl_cipher BLOB NOT NULL,\n"
  "x509_issuer BLOB NOT NULL,\n"
  "x509_subject BLOB NOT NULL,\n"
  "max_questions int(11) unsigned DEFAULT 0  NOT NULL,\n"
  "max_updates int(11) unsigned DEFAULT 0  NOT NULL,\n"
  "max_connections int(11) unsigned DEFAULT 0  NOT NULL,\n"
  "max_user_connections int(11) unsigned DEFAULT 0  NOT NULL,\n"
  "plugin char(64) DEFAULT 'caching_sha2_password' NOT NULL,\n"
  "authentication_string TEXT,\n"
  "password_expired ENUM('N', 'Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "password_last_changed timestamp NULL DEFAULT NULL,\n"
  "password_lifetime smallint unsigned NULL DEFAULT NULL,\n"
  "account_locked ENUM('N', 'Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Create_role_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Drop_role_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "Password_reuse_history smallint unsigned NULL DEFAULT NULL,\n"
  "Password_reuse_time smallint unsigned NULL DEFAULT NULL,\n"
  "Password_require_current enum('N', 'Y') COLLATE utf8_general_ci DEFAULT NULL,\n"
  "User_attributes JSON DEFAULT NULL,\n"
  "PRIMARY KEY Host (Host,User)\n"
  ") engine=InnoDB STATS_PERSISTENT=0 CHARACTER SET utf8 COLLATE utf8_bin comment='Users and global privileges' ROW_FORM"
  "AT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS default_roles\n"
  "(\n"
  "HOST CHAR(255) CHARACTER SET ASCII DEFAULT '' NOT NULL,\n"
  "USER CHAR(32) BINARY DEFAULT '' NOT NULL,\n"
  "DEFAULT_ROLE_HOST CHAR(255) CHARACTER SET ASCII DEFAULT '%' NOT NULL,\n"
  "DEFAULT_ROLE_USER CHAR(32) BINARY DEFAULT '' NOT NULL,\n"
  "PRIMARY KEY (HOST, USER, DEFAULT_ROLE_HOST, DEFAULT_ROLE_USER)\n"
  ") engine=InnoDB STATS_PERSISTENT=0 CHARACTER SET utf8 COLLATE utf8_bin comment='Default roles' ROW_FORMAT=DYNAMIC TAB"
  "LESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS role_edges\n"
  "(\n"
  "FROM_HOST CHAR(255) CHARACTER SET ASCII DEFAULT '' NOT NULL,\n"
  "FROM_USER CHAR(32) BINARY DEFAULT '' NOT NULL,\n"
  "TO_HOST CHAR(255) CHARACTER SET ASCII DEFAULT '' NOT NULL,\n"
  "TO_USER CHAR(32) BINARY DEFAULT '' NOT NULL,\n"
  "WITH_ADMIN_OPTION ENUM('N', 'Y') COLLATE UTF8_GENERAL_CI DEFAULT 'N' NOT NULL,\n"
  "PRIMARY KEY (FROM_HOST,FROM_USER,TO_HOST,TO_USER)\n"
  ") engine=InnoDB STATS_PERSISTENT=0 CHARACTER SET utf8 COLLATE utf8_bin comment='Role hierarchy and role grants' ROW_F"
  "ORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS global_grants\n"
  "(\n"
  "USER CHAR(32) BINARY DEFAULT '' NOT NULL,\n"
  "HOST CHAR(255) CHARACTER SET ASCII DEFAULT '' NOT NULL,\n"
  "PRIV CHAR(32) COLLATE UTF8_GENERAL_CI DEFAULT '' NOT NULL,\n"
  "WITH_GRANT_OPTION ENUM('N','Y') COLLATE UTF8_GENERAL_CI DEFAULT 'N' NOT NULL,\n"
  "PRIMARY KEY (USER,HOST,PRIV)\n"
  ") engine=InnoDB STATS_PERSISTENT=0 CHARACTER SET utf8 COLLATE utf8_bin comment='Extended global grants' ROW_FORMAT=DY"
  "NAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"set @had_user_table= @@warning_count != 0;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS password_history\n"
  "(\n"
  "  Host CHAR(255) CHARACTER SET ASCII DEFAULT '' NOT NULL,\n"
  "  User CHAR(32) BINARY DEFAULT '' NOT NULL,\n"
  "  Password_timestamp TIMESTAMP(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6),\n"
  "  Password TEXT,\n"
  "  PRIMARY KEY(Host, User, Password_timestamp DESC)\n"
  " ) engine=InnoDB STATS_PERSISTENT=0 CHARACTER SET utf8 COLLATE utf8_bin\n"
  " comment='Password history for user accounts' ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS func (  name char(64) binary DEFAULT '' NOT NULL, ret tinyint(1) DEFAULT '0' NOT"
  " NULL, dl char(128) DEFAULT '' NOT NULL, type enum ('function','aggregate') COLLATE utf8_general_ci NOT NULL, PRIMARY"
  " KEY (name) ) engine=INNODB STATS_PERSISTENT=0 CHARACTER SET utf8 COLLATE utf8_bin   comment='User defined functions'"
  " ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS plugin ( name varchar(64) DEFAULT '' NOT NULL, dl varchar(128) DEFAULT '' NOT NU"
  "LL, PRIMARY KEY (name) ) engine=InnoDB STATS_PERSISTENT=0 CHARACTER SET utf8 COLLATE utf8_general_ci comment='MySQL p"
  "lugins' ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS help_topic ( help_topic_id int unsigned not null, name char(64) not null, help_c"
  "ategory_id smallint unsigned not null, description text not null, example text not null, url text not null, primary k"
  "ey (help_topic_id), unique index (name) ) engine=INNODB STATS_PERSISTENT=0 CHARACTER SET utf8 comment='help topics' R"
  "OW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS help_category ( help_category_id smallint unsigned not null, name  char(64) not "
  "null, parent_category_id smallint unsigned null, url text not null, primary key (help_category_id), unique index (nam"
  "e) ) engine=INNODB STATS_PERSISTENT=0 CHARACTER SET utf8 comment='help categories' ROW_FORMAT=DYNAMIC TABLESPACE=mysq"
  "l\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS help_relation ( help_topic_id int unsigned not null, help_keyword_id  int unsign"
  "ed not null, primary key (help_keyword_id, help_topic_id) ) engine=INNODB STATS_PERSISTENT=0 CHARACTER SET utf8 comme"
  "nt='keyword-topic relation' ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS servers ( Server_name char(64) NOT NULL DEFAULT '', Host char(255) CHARACTER SET"
  " ASCII NOT NULL DEFAULT '', Db char(64) NOT NULL DEFAULT '', Username char(64) NOT NULL DEFAULT '', Password char(64)"
  " NOT NULL DEFAULT '', Port INT(4) NOT NULL DEFAULT '0', Socket char(64) NOT NULL DEFAULT '', Wrapper char(64) NOT NUL"
  "L DEFAULT '', Owner char(64) NOT NULL DEFAULT '', PRIMARY KEY (Server_name)) engine=InnoDB STATS_PERSISTENT=0 CHARACT"
  "ER SET utf8 comment='MySQL Foreign Servers table' ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS tables_priv ( Host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL, Db char(64"
  ") binary DEFAULT '' NOT NULL, User char(32) binary DEFAULT '' NOT NULL, Table_name char(64) binary DEFAULT '' NOT NUL"
  "L, Grantor varchar(288) DEFAULT '' NOT NULL, Timestamp timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT"
  "_TIMESTAMP, Table_priv set('Select','Insert','Update','Delete','Create','Drop','Grant','References','Index','Alter','"
  "Create View','Show view','Trigger') COLLATE utf8_general_ci DEFAULT '' NOT NULL, Column_priv set('Select','Insert','U"
  "pdate','References') COLLATE utf8_general_ci DEFAULT '' NOT NULL, PRIMARY KEY (Host,Db,User,Table_name), KEY Grantor "
  "(Grantor) ) engine=INNODB STATS_PERSISTENT=0 CHARACTER SET utf8   engine=InnoDB STATS_PERSISTENT=0 CHARACTER SET utf8"
  " COLLATE utf8_bin   comment='Table privileges' ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS columns_priv ( Host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL, Db char(6"
  "4) binary DEFAULT '' NOT NULL, User char(32) binary DEFAULT '' NOT NULL, Table_name char(64) binary DEFAULT '' NOT NU"
  "LL, Column_name char(64) binary DEFAULT '' NOT NULL, Timestamp timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE"
  " CURRENT_TIMESTAMP, Column_priv set('Select','Insert','Update','References') COLLATE utf8_general_ci DEFAULT '' NOT N"
  "ULL, PRIMARY KEY (Host,Db,User,Table_name,Column_name) ) engine=InnoDB STATS_PERSISTENT=0 CHARACTER SET utf8 COLLATE "
  "utf8_bin   comment='Column privileges' ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS help_keyword (   help_keyword_id  int unsigned not null, name char(64) not null,"
  " primary key (help_keyword_id), unique index (name) ) engine=INNODB STATS_PERSISTENT=0 CHARACTER SET utf8 comment='he"
  "lp keywords' ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS time_zone_name (   Name char(64) NOT NULL, Time_zone_id int unsigned NOT NULL, P"
  "RIMARY KEY Name (Name) ) engine=INNODB STATS_PERSISTENT=0 CHARACTER SET utf8   comment='Time zone names' ROW_FORMAT=D"
  "YNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS time_zone (   Time_zone_id int unsigned NOT NULL auto_increment, Use_leap_second"
  "s enum('Y','N') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL, PRIMARY KEY TzId (Time_zone_id) ) engine=INNODB STATS_P"
  "ERSISTENT=0 CHARACTER SET utf8   comment='Time zones' ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS time_zone_transition (   Time_zone_id int unsigned NOT NULL, Transition_time big"
  "int signed NOT NULL, Transition_type_id int unsigned NOT NULL, PRIMARY KEY TzIdTranTime (Time_zone_id, Transition_tim"
  "e) ) engine=INNODB STATS_PERSISTENT=0 CHARACTER SET utf8   comment='Time zone transitions' ROW_FORMAT=DYNAMIC TABLESP"
  "ACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS time_zone_transition_type (   Time_zone_id int unsigned NOT NULL, Transition_typ"
  "e_id int unsigned NOT NULL, Offset int signed DEFAULT 0 NOT NULL, Is_DST tinyint unsigned DEFAULT 0 NOT NULL, Abbrevi"
  "ation char(8) DEFAULT '' NOT NULL, PRIMARY KEY TzIdTrTId (Time_zone_id, Transition_type_id) ) engine=INNODB STATS_PER"
  "SISTENT=0 CHARACTER SET utf8   comment='Time zone transition types' ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS time_zone_leap_second (   Transition_time bigint signed NOT NULL, Correction int"
  " signed NOT NULL, PRIMARY KEY TranTime (Transition_time) ) engine=INNODB STATS_PERSISTENT=0 CHARACTER SET utf8   comm"
  "ent='Leap seconds information for time zones' ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS procs_priv ( Host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL, Db char(64)"
  " binary DEFAULT '' NOT NULL, User char(32) binary DEFAULT '' NOT NULL, Routine_name char(64) COLLATE utf8_general_ci "
  "DEFAULT '' NOT NULL, Routine_type enum('FUNCTION','PROCEDURE') NOT NULL, Grantor varchar(288) DEFAULT '' NOT NULL, Pr"
  "oc_priv set('Execute','Alter Routine','Grant') COLLATE utf8_general_ci DEFAULT '' NOT NULL, Timestamp timestamp NOT N"
  "ULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP, PRIMARY KEY (Host,Db,User,Routine_name,Routine_type), KEY "
  "Grantor (Grantor) ) engine=InnoDB STATS_PERSISTENT=0 CHARACTER SET utf8 COLLATE utf8_bin   comment='Procedure privile"
  "ges' ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @old_sql_require_primary_key = @@session.sql_require_primary_key;\n",
"SET @@session.sql_require_primary_key = 0;\n",
"CREATE TABLE IF NOT EXISTS general_log (event_time TIMESTAMP(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_"
  "TIMESTAMP(6), user_host MEDIUMTEXT NOT NULL, thread_id BIGINT(21) UNSIGNED NOT NULL, server_id INTEGER UNSIGNED NOT N"
  "ULL, command_type VARCHAR(64) NOT NULL, argument MEDIUMBLOB NOT NULL) engine=CSV CHARACTER SET utf8 comment=\"General"
  " log\";\n",
"CREATE TABLE IF NOT EXISTS slow_log (start_time TIMESTAMP(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIM"
  "ESTAMP(6), user_host MEDIUMTEXT NOT NULL, query_time TIME(6) NOT NULL, lock_time TIME(6) NOT NULL, rows_sent INTEGER "
  "NOT NULL, rows_examined INTEGER NOT NULL, db VARCHAR(512) NOT NULL, last_insert_id INTEGER NOT NULL, insert_id INTEGE"
  "R NOT NULL, server_id INTEGER UNSIGNED NOT NULL, sql_text MEDIUMBLOB NOT NULL, thread_id BIGINT(21) UNSIGNED NOT NULL"
  ") engine=CSV CHARACTER SET utf8 comment=\"Slow log\";\n",
"SET @@session.sql_require_primary_key = @old_sql_require_primary_key;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS component ( component_id int unsigned NOT NULL AUTO_INCREMENT, component_group_i"
  "d int unsigned NOT NULL, component_urn text NOT NULL, PRIMARY KEY (component_id)) engine=INNODB DEFAULT CHARSET=utf8 "
  "COMMENT 'Components' ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"CREATE TABLE IF NOT EXISTS slave_relay_log_info (\n"
  "  Number_of_lines INTEGER UNSIGNED NOT NULL COMMENT 'Number of lines in the file or rows in the table. Used to versio"
  "n table definitions.',\n"
  "  Relay_log_name TEXT CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The name of the current relay log file.',"
  "\n"
  "  Relay_log_pos BIGINT UNSIGNED NOT NULL COMMENT 'The relay log position of the last executed event.',\n"
  "  Master_log_name TEXT CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The name of the master binary log file f"
  "rom which the events in the relay log file were read.',\n"
  "  Master_log_pos BIGINT UNSIGNED NOT NULL COMMENT 'The master log position of the last executed event.',\n"
  "  Sql_delay INTEGER NOT NULL COMMENT 'The number of seconds that the slave must lag behind the master.',\n"
  "  Number_of_workers INTEGER UNSIGNED NOT NULL,\n"
  "  Id INTEGER UNSIGNED NOT NULL COMMENT 'Internal Id that uniquely identifies this record.',\n"
  "  Channel_name CHAR(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'The channel on which the slave i"
  "s connected to a source. Used in Multisource Replication',\n"
  "  PRIMARY KEY(Channel_name)) DEFAULT CHARSET=utf8 STATS_PERSISTENT=0 COMMENT 'Relay Log Information'\";\n",
"SET @str=IF(@have_innodb <> 0, CONCAT(@cmd, ' ENGINE= INNODB ROW_FORMAT=DYNAMIC TABLESPACE=mysql ENCRYPTION=\\'', @is_mys"
  "ql_encrypted,'\\''), CONCAT(@cmd, ' ENGINE= MYISAM'));\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd= \"CREATE TABLE IF NOT EXISTS slave_master_info (\n"
  "  Number_of_lines INTEGER UNSIGNED NOT NULL COMMENT 'Number of lines in the file.',\n"
  "  Master_log_name TEXT CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The name of the master binary log curren"
  "tly being read from the master.',\n"
  "  Master_log_pos BIGINT UNSIGNED NOT NULL COMMENT 'The master log position of the last read event.',\n"
  "  Host CHAR(255) CHARACTER SET ASCII COMMENT 'The host name of the master.',\n"
  "  User_name TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The user name used to connect to the master.',\n"
  "  User_password TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The password used to connect to the master.',\n"
  "  Port INTEGER UNSIGNED NOT NULL COMMENT 'The network port used to connect to the master.',\n"
  "  Connect_retry INTEGER UNSIGNED NOT NULL COMMENT 'The period (in seconds) that the slave will wait before trying to "
  "reconnect to the master.',\n"
  "  Enabled_ssl BOOLEAN NOT NULL COMMENT 'Indicates whether the server supports SSL connections.',\n"
  "  Ssl_ca TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The file used for the Certificate Authority (CA) certifica"
  "te.',\n"
  "  Ssl_capath TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The path to the Certificate Authority (CA) certificate"
  "s.',\n"
  "  Ssl_cert TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The name of the SSL certificate file.',\n"
  "  Ssl_cipher TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The name of the cipher in use for the SSL connection.'"
  ",\n"
  "  Ssl_key TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The name of the SSL key file.',\n"
  "  Ssl_verify_server_cert BOOLEAN NOT NULL COMMENT 'Whether to verify the server certificate.',\n"
  "  Heartbeat FLOAT NOT NULL COMMENT '',\n"
  "  Bind TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'Displays which interface is employed when connecting to the "
  "MySQL server',\n"
  "  Ignored_server_ids TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The number of server IDs to be ignored, follow"
  "ed by the actual server IDs',\n"
  "  Uuid TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The master server uuid.',\n"
  "  Retry_count BIGINT UNSIGNED NOT NULL COMMENT 'Number of reconnect attempts, to the master, before giving up.',\n"
  "  Ssl_crl TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The file used for the Certificate Revocation List (CRL)',"
  "\n"
  "  Ssl_crlpath TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The path used for Certificate Revocation List (CRL) f"
  "iles',\n"
  "  Enabled_auto_position BOOLEAN NOT NULL COMMENT 'Indicates whether GTIDs will be used to retrieve events from the ma"
  "ster.',\n"
  "  Channel_name CHAR(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'The channel on which the slave i"
  "s connected to a source. Used in Multisource Replication',\n"
  "  Tls_version TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'Tls version',\n"
  "  Public_key_path TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The file containing public key of master server.'"
  ",\n"
  "  Get_public_key BOOLEAN NOT NULL COMMENT 'Preference to get public key from master.',\n"
  "  Network_namespace TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'Network namespace used for communication with t"
  "he master server.',\n"
  "  PRIMARY KEY(Channel_name)) DEFAULT CHARSET=utf8 STATS_PERSISTENT=0 COMMENT 'Master Information'\";\n",
"SET @str=IF(@have_innodb <> 0, CONCAT(@cmd, ' ENGINE= INNODB ROW_FORMAT=DYNAMIC TABLESPACE=mysql ENCRYPTION=\\'', @is_mys"
  "ql_encrypted,'\\''), CONCAT(@cmd, ' ENGINE= MYISAM'));\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd= \"CREATE TABLE IF NOT EXISTS slave_worker_info (\n"
  "  Id INTEGER UNSIGNED NOT NULL,\n"
  "  Relay_log_name TEXT CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,\n"
  "  Relay_log_pos BIGINT UNSIGNED NOT NULL,\n"
  "  Master_log_name TEXT CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,\n"
  "  Master_log_pos BIGINT UNSIGNED NOT NULL,\n"
  "  Checkpoint_relay_log_name TEXT CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,\n"
  "  Checkpoint_relay_log_pos BIGINT UNSIGNED NOT NULL,\n"
  "  Checkpoint_master_log_name TEXT CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,\n"
  "  Checkpoint_master_log_pos BIGINT UNSIGNED NOT NULL,\n"
  "  Checkpoint_seqno INT UNSIGNED NOT NULL,\n"
  "  Checkpoint_group_size INTEGER UNSIGNED NOT NULL,\n"
  "  Checkpoint_group_bitmap BLOB NOT NULL,\n"
  "  Channel_name CHAR(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'The channel on which the slave i"
  "s connected to a source. Used in Multisource Replication',\n"
  "  PRIMARY KEY(Channel_name, Id)) DEFAULT CHARSET=utf8 STATS_PERSISTENT=0 COMMENT 'Worker Information'\";\n",
"SET @str=IF(@have_innodb <> 0, CONCAT(@cmd, ' ENGINE= INNODB ROW_FORMAT=DYNAMIC TABLESPACE=mysql ENCRYPTION=\\'', @is_mys"
  "ql_encrypted,'\\''), CONCAT(@cmd, ' ENGINE= MYISAM'));\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd= \"CREATE TABLE IF NOT EXISTS gtid_executed (\n"
  "    source_uuid CHAR(36) NOT NULL COMMENT 'uuid of the source where the transaction was originally executed.',\n"
  "    interval_start BIGINT NOT NULL COMMENT 'First number of interval.',\n"
  "    interval_end BIGINT NOT NULL COMMENT 'Last number of interval.',\n"
  "    PRIMARY KEY(source_uuid, interval_start))\";\n",
"SET @str=IF(@have_innodb <> 0, CONCAT(@cmd, ' ENGINE= INNODB ROW_FORMAT=DYNAMIC TABLESPACE=mysql ENCRYPTION=\\'', @is_mys"
  "ql_encrypted,'\\''), CONCAT(@cmd, ' ENGINE= MYISAM'));\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS server_cost (\n"
  "  cost_name   VARCHAR(64) NOT NULL,\n"
  "  cost_value  FLOAT DEFAULT NULL,\n"
  "  last_update TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,\n"
  "  comment     VARCHAR(1024) DEFAULT NULL,\n"
  "  default_value FLOAT GENERATED ALWAYS AS\n"
  "    (CASE cost_name\n"
  "       WHEN 'disk_temptable_create_cost' THEN 20.0\n"
  "       WHEN 'disk_temptable_row_cost' THEN 0.5\n"
  "       WHEN 'key_compare_cost' THEN 0.05\n"
  "       WHEN 'memory_temptable_create_cost' THEN 1.0\n"
  "       WHEN 'memory_temptable_row_cost' THEN 0.1\n"
  "       WHEN 'row_evaluate_cost' THEN 0.1\n"
  "       ELSE NULL\n"
  "     END) VIRTUAL,\n"
  "  PRIMARY KEY (cost_name)\n"
  ") ENGINE=InnoDB CHARACTER SET=utf8 COLLATE=utf8_general_ci STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"INSERT IGNORE INTO server_cost(cost_name) VALUES\n"
  "  (\"row_evaluate_cost\"), (\"key_compare_cost\"),\n"
  "  (\"memory_temptable_create_cost\"), (\"memory_temptable_row_cost\"),\n"
  "  (\"disk_temptable_create_cost\"), (\"disk_temptable_row_cost\");\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS engine_cost (\n"
  "  engine_name VARCHAR(64) NOT NULL,\n"
  "  device_type INTEGER NOT NULL,\n"
  "  cost_name   VARCHAR(64) NOT NULL,\n"
  "  cost_value  FLOAT DEFAULT NULL,\n"
  "  last_update TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,\n"
  "  comment     VARCHAR(1024) DEFAULT NULL,\n"
  "  default_value FLOAT GENERATED ALWAYS AS\n"
  "    (CASE cost_name\n"
  "       WHEN 'io_block_read_cost' THEN 1.0\n"
  "       WHEN 'memory_block_read_cost' THEN 0.25\n"
  "       ELSE NULL\n"
  "     END) VIRTUAL,\n"
  "  PRIMARY KEY (cost_name, engine_name, device_type)\n"
  ") ENGINE=InnoDB CHARACTER SET=utf8 COLLATE=utf8_general_ci STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"INSERT IGNORE INTO engine_cost(engine_name, device_type, cost_name) VALUES\n"
  "  (\"default\", 0, \"memory_block_read_cost\"),\n"
  "  (\"default\", 0, \"io_block_read_cost\");\n",
"SET @cmd = \"CREATE TABLE IF NOT EXISTS proxies_priv (Host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL, User char("
  "32) binary DEFAULT '' NOT NULL, Proxied_host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL, Proxied_user char(32)"
  " binary DEFAULT '' NOT NULL, With_grant BOOL DEFAULT 0 NOT NULL, Grantor varchar(288) DEFAULT '' NOT NULL, Timestamp "
  "timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP, PRIMARY KEY Host (Host,User,Proxied_host,Pr"
  "oxied_user), KEY Grantor (Grantor) ) engine=InnoDB STATS_PERSISTENT=0 CHARACTER SET utf8 COLLATE utf8_bin comment='Us"
  "er proxy privileges' ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"set @had_proxies_priv_table= @@warning_count != 0;\n",
"SET @have_ndb= (select count(engine) from information_schema.engines where engine='ndbcluster');\n",
"SET @cmd=\"CREATE TABLE IF NOT EXISTS ndb_binlog_index (\n"
  "  Position BIGINT UNSIGNED NOT NULL,\n"
  "  File VARCHAR(255) NOT NULL,\n"
  "  epoch BIGINT UNSIGNED NOT NULL,\n"
  "  inserts INT UNSIGNED NOT NULL,\n"
  "  updates INT UNSIGNED NOT NULL,\n"
  "  deletes INT UNSIGNED NOT NULL,\n"
  "  schemaops INT UNSIGNED NOT NULL,\n"
  "  orig_server_id INT UNSIGNED NOT NULL,\n"
  "  orig_epoch BIGINT UNSIGNED NOT NULL,\n"
  "  gci INT UNSIGNED NOT NULL,\n"
  "  next_position BIGINT UNSIGNED NOT NULL,\n"
  "  next_file VARCHAR(255) NOT NULL,\n"
  "  PRIMARY KEY(epoch, orig_server_id, orig_epoch)\n"
  "  ) ENGINE=INNODB CHARACTER SET latin1 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC TABLESPACE=mysql\";\n",
"SET @str = CONCAT(@cmd, \" ENCRYPTION='\", @is_mysql_encrypted, \"'\");\n",
"SET @str = IF(@have_ndb = 1, @str, 'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @old_sql_require_primary_key = @@session.sql_require_primary_key;\n",
"SET @@session.sql_require_primary_key = 0;\n",
"SET NAMES 'latin1' COLLATE 'latin1_swedish_ci';\n",
"SELECT @have_ndbinfo:= COUNT(*) FROM information_schema.engines WHERE engine='NDBINFO' AND support IN ('YES', 'DEFAULT')"
  ";\n",
"SET @str=IF(@have_ndbinfo,'SELECT @have_ndbinfo:= (@@ndbinfo_version >= (7 << 16) | (1 << 8)) || @ndbinfo_skip_version_c"
  "heck','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE DATABASE IF NOT EXISTS `ndbinfo`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'SET @@global.ndbinfo_offline=TRUE','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`blocks`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`config_params`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`dict_obj_types`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$dblqh_tcconnect_state`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$dbtc_apiconnect_state`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`arbitrator_validity_detail`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`arbitrator_validity_summary`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`blocks`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`cluster_locks`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`cluster_operations`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`cluster_transactions`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`config_nodes`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`config_params`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`config_values`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`counters`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`cpustat`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`cpustat_1sec`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`cpustat_20sec`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`cpustat_50ms`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`dict_obj_info`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`dict_obj_types`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`disk_write_speed_aggregate`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`disk_write_speed_aggregate_node`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`disk_write_speed_base`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`diskpagebuffer`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`error_messages`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`locks_per_fragment`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`logbuffers`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`logspaces`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`membership`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`memory_per_fragment`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`memoryusage`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`nodes`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`operations_per_fragment`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`processes`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`resources`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`restart_info`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`server_locks`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`server_operations`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`server_transactions`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`table_distribution_status`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`table_fragments`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`table_info`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`table_replicas`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`tc_time_track_stats`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`threadblocks`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`threads`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`threadstat`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP VIEW IF EXISTS `ndbinfo`.`transporters`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$blocks`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$config_params`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$dblqh_tcconnect_state`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$dbtc_apiconnect_state`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$dict_obj_types`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$error_messages`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$acc_operations`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$acc_operations` (`node_id` INT UNSIGNED COMMENT \"node_id\",`bloc"
  "k_instance` INT UNSIGNED COMMENT \"Block instance\",`tableid` INT UNSIGNED COMMENT \"Table id\",`fragmentid` INT UNSI"
  "GNED COMMENT \"Fragment id\",`rowid` BIGINT UNSIGNED COMMENT \"Row id in fragment\",`transid0` INT UNSIGNED COMMENT \""
  "Transaction id\",`transid1` INT UNSIGNED COMMENT \"Transaction id\",`acc_op_id` INT UNSIGNED COMMENT \"Operation id\""
  ",`op_flags` INT UNSIGNED COMMENT \"Operation flags\",`prev_serial_op_id` INT UNSIGNED COMMENT \"Prev serial op id\",`"
  "next_serial_op_id` INT UNSIGNED COMMENT \"Next serial op id\",`prev_parallel_op_id` INT UNSIGNED COMMENT \"Prev paral"
  "lel op id\",`next_parallel_op_id` INT UNSIGNED COMMENT \"Next parallel op id\",`duration_millis` INT UNSIGNED COMMENT"
  " \"Duration of wait/hold\",`user_ptr` INT UNSIGNED COMMENT \"Lock requestor context\") COMMENT=\"ACC operation info\""
  " ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$columns`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$columns` (`table_id` INT UNSIGNED,`column_id` INT UNSIGNED,`colum"
  "n_name` VARCHAR(512),`column_type` INT UNSIGNED,`comment` VARCHAR(512)) COMMENT=\"metadata for columns available thro"
  "ugh ndbinfo \" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$config_nodes`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$config_nodes` (`reporting_node_id` INT UNSIGNED COMMENT \"Reporti"
  "ng data node ID\",`node_id` INT UNSIGNED COMMENT \"Configured node ID\",`node_type` INT UNSIGNED COMMENT \"Configured"
  " node type\",`node_hostname` VARCHAR(512) COMMENT \"Configured hostname\") COMMENT=\"All nodes of current cluster con"
  "figuration\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$config_values`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$config_values` (`node_id` INT UNSIGNED,`config_param` INT UNSIGNE"
  "D COMMENT \"Parameter number\",`config_value` VARCHAR(512) COMMENT \"Parameter value\") COMMENT=\"Configuration param"
  "eter values\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$counters`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$counters` (`node_id` INT UNSIGNED,`block_number` INT UNSIGNED,`bl"
  "ock_instance` INT UNSIGNED,`counter_id` INT UNSIGNED,`val` BIGINT UNSIGNED COMMENT \"monotonically increasing since p"
  "rocess start\") COMMENT=\"monotonic counters\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$cpustat`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$cpustat` (`node_id` INT UNSIGNED COMMENT \"node_id\",`thr_no` INT"
  " UNSIGNED COMMENT \"thread number\",`OS_user` INT UNSIGNED COMMENT \"Percentage time spent in user mode as reported b"
  "y OS\",`OS_system` INT UNSIGNED COMMENT \"Percentage time spent in system mode as reported by OS\",`OS_idle` INT UNSI"
  "GNED COMMENT \"Percentage time spent in idle mode as reported by OS\",`thread_exec` INT UNSIGNED COMMENT \"Percentage"
  " time spent executing as calculated by thread\",`thread_sleeping` INT UNSIGNED COMMENT \"Percentage time spent sleepi"
  "ng as calculated by thread\",`thread_spinning` INT UNSIGNED COMMENT \"Percentage time spent spinning as calculated by"
  " thread\",`thread_send` INT UNSIGNED COMMENT \"Percentage time spent sending as calculated by thread\",`thread_buffer"
  "_full` INT UNSIGNED COMMENT \"Percentage time spent in buffer full as calculated by thread\",`elapsed_time` INT UNSIG"
  "NED COMMENT \"Elapsed time in microseconds for measurement\") COMMENT=\"Thread CPU stats for last second\" ENGINE=NDB"
  "INFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$cpustat_1sec`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$cpustat_1sec` (`node_id` INT UNSIGNED COMMENT \"node_id\",`thr_no"
  "` INT UNSIGNED COMMENT \"thread number\",`OS_user_time` INT UNSIGNED COMMENT \"User time in microseconds as reported "
  "by OS\",`OS_system_time` INT UNSIGNED COMMENT \"System time in microseconds as reported by OS\",`OS_idle_time` INT UN"
  "SIGNED COMMENT \"Idle time in microseconds as reported by OS\",`exec_time` INT UNSIGNED COMMENT \"Execution time in m"
  "icroseconds as calculated by thread\",`sleep_time` INT UNSIGNED COMMENT \"Sleep time in microseconds as calculated by"
  " thread\",`spin_time` INT UNSIGNED COMMENT \"Spin time in microseconds as calculated by thread\",`send_time` INT UNSI"
  "GNED COMMENT \"Send time in microseconds as calculated by thread\",`buffer_full_time` INT UNSIGNED COMMENT \"Time spe"
  "nt with buffer full in microseconds as calculated by thread\",`elapsed_time` INT UNSIGNED COMMENT \"Elapsed time in m"
  "icroseconds for measurement\") COMMENT=\"Thread CPU stats at 1 second intervals\" ENGINE=NDBINFO CHARACTER SET latin1"
  "','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$cpustat_20sec`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$cpustat_20sec` (`node_id` INT UNSIGNED COMMENT \"node_id\",`thr_n"
  "o` INT UNSIGNED COMMENT \"thread number\",`OS_user_time` INT UNSIGNED COMMENT \"User time in microseconds as reported"
  " by OS\",`OS_system_time` INT UNSIGNED COMMENT \"System time in microseconds as reported by OS\",`OS_idle_time` INT U"
  "NSIGNED COMMENT \"Idle time in microseconds as reported by OS\",`exec_time` INT UNSIGNED COMMENT \"Execution time in "
  "microseconds as calculated by thread\",`sleep_time` INT UNSIGNED COMMENT \"Sleep time in microseconds as calculated b"
  "y thread\",`spin_time` INT UNSIGNED COMMENT \"Spin time in microseconds as calculated by thread\",`send_time` INT UNS"
  "IGNED COMMENT \"Send time in microseconds as calculated by thread\",`buffer_full_time` INT UNSIGNED COMMENT \"Time sp"
  "ent with buffer full in microseconds as calculated by thread\",`elapsed_time` INT UNSIGNED COMMENT \"Elapsed time in "
  "microseconds for measurement\") COMMENT=\"Thread CPU stats at 20 seconds intervals\" ENGINE=NDBINFO CHARACTER SET lat"
  "in1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$cpustat_50ms`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$cpustat_50ms` (`node_id` INT UNSIGNED COMMENT \"node_id\",`thr_no"
  "` INT UNSIGNED COMMENT \"thread number\",`OS_user_time` INT UNSIGNED COMMENT \"User time in microseconds as reported "
  "by OS\",`OS_system_time` INT UNSIGNED COMMENT \"System time in microseconds as reported by OS\",`OS_idle_time` INT UN"
  "SIGNED COMMENT \"Idle time in microseconds as reported by OS\",`exec_time` INT UNSIGNED COMMENT \"Execution time in m"
  "icroseconds as calculated by thread\",`sleep_time` INT UNSIGNED COMMENT \"Sleep time in microseconds as calculated by"
  " thread\",`spin_time` INT UNSIGNED COMMENT \"Spin time in microseconds as calculated by thread\",`send_time` INT UNSI"
  "GNED COMMENT \"Send time in microseconds as calculated by thread\",`buffer_full_time` INT UNSIGNED COMMENT \"Time spe"
  "nt with buffer full in microseconds as calculated by thread\",`elapsed_time` INT UNSIGNED COMMENT \"Elapsed time in m"
  "icroseconds for measurement\") COMMENT=\"Thread CPU stats at 50 milliseconds intervals\" ENGINE=NDBINFO CHARACTER SET"
  " latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$dict_obj_info`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$dict_obj_info` (`type` INT UNSIGNED COMMENT \"Type of dict object"
  "\",`id` INT UNSIGNED COMMENT \"Object identity\",`version` INT UNSIGNED COMMENT \"Object version\",`state` INT UNSIGN"
  "ED COMMENT \"Object state\",`parent_obj_type` INT UNSIGNED COMMENT \"Parent object type\",`parent_obj_id` INT UNSIGNE"
  "D COMMENT \"Parent object id\",`fq_name` VARCHAR(512) COMMENT \"Fully qualified object name\") COMMENT=\"Dictionary o"
  "bject info\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$disk_write_speed_aggregate`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$disk_write_speed_aggregate` (`node_id` INT UNSIGNED COMMENT \"nod"
  "e id\",`thr_no` INT UNSIGNED COMMENT \"LDM thread instance\",`backup_lcp_speed_last_sec` BIGINT UNSIGNED COMMENT \"Nu"
  "mber of bytes written by backup and LCP last second\",`redo_speed_last_sec` BIGINT UNSIGNED COMMENT \"Number of bytes"
  " written to REDO log last second\",`backup_lcp_speed_last_10sec` BIGINT UNSIGNED COMMENT \"Number of bytes written by"
  " backup and LCP per second last 10 seconds\",`redo_speed_last_10sec` BIGINT UNSIGNED COMMENT \"Number of bytes writte"
  "n to REDO log per second last 10 seconds\",`std_dev_backup_lcp_speed_last_10sec` BIGINT UNSIGNED COMMENT \"Standard d"
  "eviation of Number of bytes written by backup and LCP per second last 10 seconds\",`std_dev_redo_speed_last_10sec` BI"
  "GINT UNSIGNED COMMENT \"Standard deviation of Number of bytes written to REDO log per second last 10 seconds\",`backu"
  "p_lcp_speed_last_60sec` BIGINT UNSIGNED COMMENT \"Number of bytes written by backup and LCP per second last 60 second"
  "s\",`redo_speed_last_60sec` BIGINT UNSIGNED COMMENT \"Number of bytes written to REDO log per second last 60 seconds\""
  ",`std_dev_backup_lcp_speed_last_60sec` BIGINT UNSIGNED COMMENT \"Standard deviation of Number of bytes written by bac"
  "kup and LCP per second last 60 seconds\",`std_dev_redo_speed_last_60sec` BIGINT UNSIGNED COMMENT \"Standard deviation"
  " of Number of bytes written to REDO log per second last 60 seconds\",`slowdowns_due_to_io_lag` BIGINT UNSIGNED COMMEN"
  "T \"Number of seconds that we slowed down disk writes due to REDO log IO lagging\",`slowdowns_due_to_high_cpu` BIGINT"
  " UNSIGNED COMMENT \"Number of seconds we slowed down disk writes due to high CPU usage of LDM thread\",`disk_write_sp"
  "eed_set_to_min` BIGINT UNSIGNED COMMENT \"Number of seconds we set disk write speed to a minimum\",`current_target_di"
  "sk_write_speed` BIGINT UNSIGNED COMMENT \"Current target of disk write speed in bytes per second\") COMMENT=\"Actual "
  "speed of disk writes per LDM thread, aggregate data\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$disk_write_speed_base`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$disk_write_speed_base` (`node_id` INT UNSIGNED COMMENT \"node id\""
  ",`thr_no` INT UNSIGNED COMMENT \"LDM thread instance\",`millis_ago` BIGINT UNSIGNED COMMENT \"Milliseconds ago since "
  "this period finished\",`millis_passed` BIGINT UNSIGNED COMMENT \"Milliseconds passed in the period reported\",`backup"
  "_lcp_bytes_written` BIGINT UNSIGNED COMMENT \"Bytes written by backup and LCP in the period\",`redo_bytes_written` BI"
  "GINT UNSIGNED COMMENT \"Bytes written to REDO log in the period\",`target_disk_write_speed` BIGINT UNSIGNED COMMENT \""
  "Target disk write speed in bytes per second at the measurement point\") COMMENT=\"Actual speed of disk writes per LDM"
  " thread, base data\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$diskpagebuffer`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$diskpagebuffer` (`node_id` INT UNSIGNED,`block_instance` INT UNSI"
  "GNED,`pages_written` BIGINT UNSIGNED COMMENT \"Pages written to disk\",`pages_written_lcp` BIGINT UNSIGNED COMMENT \""
  "Pages written by local checkpoint\",`pages_read` BIGINT UNSIGNED COMMENT \"Pages read from disk\",`log_waits` BIGINT "
  "UNSIGNED COMMENT \"Page writes waiting for log to be written to disk\",`page_requests_direct_return` BIGINT UNSIGNED "
  "COMMENT \"Page in buffer and no requests waiting for it\",`page_requests_wait_queue` BIGINT UNSIGNED COMMENT \"Page i"
  "n buffer, but some requests are already waiting for it\",`page_requests_wait_io` BIGINT UNSIGNED COMMENT \"Page not i"
  "n buffer, waiting to be read from disk\") COMMENT=\"disk page buffer info\" ENGINE=NDBINFO CHARACTER SET latin1','SET"
  " @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$frag_locks`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$frag_locks` (`node_id` INT UNSIGNED COMMENT \"node id\",`block_in"
  "stance` INT UNSIGNED COMMENT \"LQH instance no\",`table_id` INT UNSIGNED COMMENT \"Table identity\",`fragment_num` IN"
  "T UNSIGNED COMMENT \"Fragment number\",`ex_req` BIGINT UNSIGNED COMMENT \"Exclusive row lock request count\",`ex_imm_"
  "ok` BIGINT UNSIGNED COMMENT \"Exclusive row lock immediate grants\",`ex_wait_ok` BIGINT UNSIGNED COMMENT \"Exclusive "
  "row lock grants with wait\",`ex_wait_fail` BIGINT UNSIGNED COMMENT \"Exclusive row lock failed grants\",`sh_req` BIGI"
  "NT UNSIGNED COMMENT \"Shared row lock request count\",`sh_imm_ok` BIGINT UNSIGNED COMMENT \"Shared row lock immediate"
  " grants\",`sh_wait_ok` BIGINT UNSIGNED COMMENT \"Shared row lock grants with wait\",`sh_wait_fail` BIGINT UNSIGNED CO"
  "MMENT \"Shared row lock failed grants\",`wait_ok_millis` BIGINT UNSIGNED COMMENT \"Time spent waiting before successf"
  "ully claiming a lock\",`wait_fail_millis` BIGINT UNSIGNED COMMENT \"Time spent waiting before failing to claim a lock"
  "\") COMMENT=\"Per fragment lock information\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$frag_mem_use`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$frag_mem_use` (`node_id` INT UNSIGNED COMMENT \"node id\",`block_"
  "instance` INT UNSIGNED COMMENT \"LDM instance number\",`table_id` INT UNSIGNED COMMENT \"Table identity\",`fragment_n"
  "um` INT UNSIGNED COMMENT \"Fragment number\",`rows` BIGINT UNSIGNED COMMENT \"Number of rows in table\",`fixed_elem_a"
  "lloc_bytes` BIGINT UNSIGNED COMMENT \"Number of bytes allocated for fixed-sized elements\",`fixed_elem_free_bytes` BI"
  "GINT UNSIGNED COMMENT \"Free bytes in fixed-size element pages\",`fixed_elem_count` BIGINT UNSIGNED COMMENT \"Number "
  "of fixed size elements in use\",`fixed_elem_size_bytes` INT UNSIGNED COMMENT \"Length of each fixed sized element in "
  "bytes\",`var_elem_alloc_bytes` BIGINT UNSIGNED COMMENT \"Number of bytes allocated for var-size elements\",`var_elem_"
  "free_bytes` BIGINT UNSIGNED COMMENT \"Free bytes in var-size element pages\",`var_elem_count` BIGINT UNSIGNED COMMENT"
  " \"Number of var size elements in use\",`tuple_l2pmap_alloc_bytes` BIGINT UNSIGNED COMMENT \"Bytes in logical to phys"
  "ical page map for tuple store\",`hash_index_l2pmap_alloc_bytes` BIGINT UNSIGNED COMMENT \"Bytes in logical to physica"
  "l page map for the hash index\",`hash_index_alloc_bytes` BIGINT UNSIGNED COMMENT \"Bytes in linear hash map\") COMMEN"
  "T=\"Per fragment space information\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$frag_operations`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$frag_operations` (`node_id` INT UNSIGNED COMMENT \"node id\",`blo"
  "ck_instance` INT UNSIGNED COMMENT \"LQH instance no\",`table_id` INT UNSIGNED COMMENT \"Table identity\",`fragment_nu"
  "m` INT UNSIGNED COMMENT \"Fragment number\",`tot_key_reads` BIGINT UNSIGNED COMMENT \"Total number of key reads recei"
  "ved\",`tot_key_inserts` BIGINT UNSIGNED COMMENT \"Total number of key inserts received\",`tot_key_updates` BIGINT UNS"
  "IGNED COMMENT \"Total number of key updates received\",`tot_key_writes` BIGINT UNSIGNED COMMENT \"Total number of key"
  " writes received\",`tot_key_deletes` BIGINT UNSIGNED COMMENT \"Total number of key deletes received\",`tot_key_refs` "
  "BIGINT UNSIGNED COMMENT \"Total number of key operations refused by LDM\",`tot_key_attrinfo_bytes` BIGINT UNSIGNED CO"
  "MMENT \"Total attrinfo bytes received for key operations\",`tot_key_keyinfo_bytes` BIGINT UNSIGNED COMMENT \"Total ke"
  "yinfo bytes received for key operations\",`tot_key_prog_bytes` BIGINT UNSIGNED COMMENT \"Total bytes of filter progra"
  "ms for key operations\",`tot_key_inst_exec` BIGINT UNSIGNED COMMENT \"Total number of interpreter instructions execut"
  "ed for key operations\",`tot_key_bytes_returned` BIGINT UNSIGNED COMMENT \"Total number of bytes returned to client f"
  "or key operations\",`tot_frag_scans` BIGINT UNSIGNED COMMENT \"Total number of fragment scans received\",`tot_scan_ro"
  "ws_examined` BIGINT UNSIGNED COMMENT \"Total number of rows examined by scans\",`tot_scan_rows_returned` BIGINT UNSIG"
  "NED COMMENT \"Total number of rows returned to client by scan\",`tot_scan_bytes_returned` BIGINT UNSIGNED COMMENT \"T"
  "otal number of bytes returned to client by scans\",`tot_scan_prog_bytes` BIGINT UNSIGNED COMMENT \"Total bytes of sca"
  "n filter programs\",`tot_scan_bound_bytes` BIGINT UNSIGNED COMMENT \"Total bytes of scan bounds\",`tot_scan_inst_exec"
  "` BIGINT UNSIGNED COMMENT \"Total number of interpreter instructions executed for scans\",`tot_qd_frag_scans` BIGINT "
  "UNSIGNED COMMENT \"Total number of fragment scans queued before exec\",`conc_frag_scans` INT UNSIGNED COMMENT \"Numbe"
  "r of frag scans currently running\",`conc_qd_plain_frag_scans` INT UNSIGNED COMMENT \"Number of tux frag scans curren"
  "tly queued\",`conc_qd_tup_frag_scans` INT UNSIGNED COMMENT \"Number of tup frag scans currently queued\",`conc_qd_acc"
  "_frag_scans` INT UNSIGNED COMMENT \"Number of acc frag scans currently queued\",`tot_commits` BIGINT UNSIGNED COMMENT"
  " \"Total number of committed row changes\") COMMENT=\"Per fragment operational information\" ENGINE=NDBINFO CHARACTER"
  " SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$logbuffers`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$logbuffers` (`node_id` INT UNSIGNED,`log_type` INT UNSIGNED COMME"
  "NT \"0 = REDO, 1 = DD-UNDO, 2 = BACKUP-DATA, 3 = BACKUP-LOG\",`log_id` INT UNSIGNED,`log_part` INT UNSIGNED,`total` B"
  "IGINT UNSIGNED COMMENT \"total allocated\",`used` BIGINT UNSIGNED COMMENT \"currently in use\",`high` BIGINT UNSIGNED"
  " COMMENT \"in use high water mark\") COMMENT=\"logbuffer usage\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0"
  "');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$logspaces`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$logspaces` (`node_id` INT UNSIGNED,`log_type` INT UNSIGNED COMMEN"
  "T \"0 = REDO, 1 = DD-UNDO\",`log_id` INT UNSIGNED,`log_part` INT UNSIGNED,`total` BIGINT UNSIGNED COMMENT \"total all"
  "ocated\",`used` BIGINT UNSIGNED COMMENT \"currently in use\",`high` BIGINT UNSIGNED COMMENT \"in use high water mark\""
  ") COMMENT=\"logspace usage\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$membership`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$membership` (`node_id` INT UNSIGNED COMMENT \"node id\",`group_id"
  "` INT UNSIGNED COMMENT \"node group id\",`left_node` INT UNSIGNED COMMENT \"Left node in heart beat chain\",`right_no"
  "de` INT UNSIGNED COMMENT \"Right node in heart beat chain\",`president` INT UNSIGNED COMMENT \"President nodeid\",`su"
  "ccessor` INT UNSIGNED COMMENT \"President successor\",`dynamic_id` INT UNSIGNED COMMENT \"President, Configured_heart"
  "beat order\",`arbitrator` INT UNSIGNED COMMENT \"Arbitrator nodeid\",`arb_ticket` VARCHAR(512) COMMENT \"Arbitrator t"
  "icket\",`arb_state` INT UNSIGNED COMMENT \"Arbitrator state\",`arb_connected` INT UNSIGNED COMMENT \"Arbitrator conne"
  "cted\",`conn_rank1_arbs` VARCHAR(512) COMMENT \"Connected rank 1 arbitrators\",`conn_rank2_arbs` VARCHAR(512) COMMENT"
  " \"Connected rank 2 arbitrators\") COMMENT=\"membership\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$nodes`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$nodes` (`node_id` INT UNSIGNED,`uptime` BIGINT UNSIGNED COMMENT \""
  "time in seconds that node has been running\",`status` INT UNSIGNED COMMENT \"starting/started/stopped etc.\",`start_p"
  "hase` INT UNSIGNED COMMENT \"start phase if node is starting\",`config_generation` INT UNSIGNED COMMENT \"configurati"
  "on generation number\") COMMENT=\"node status\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$operations`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$operations` (`node_id` INT UNSIGNED COMMENT \"node id\",`block_in"
  "stance` INT UNSIGNED COMMENT \"LQH instance no\",`objid` INT UNSIGNED COMMENT \"Object id of operation object\",`tcre"
  "f` INT UNSIGNED COMMENT \"TC reference\",`apiref` INT UNSIGNED COMMENT \"API reference\",`transid0` INT UNSIGNED COMM"
  "ENT \"Transaction id\",`transid1` INT UNSIGNED COMMENT \"Transaction id\",`tableid` INT UNSIGNED COMMENT \"Table id\""
  ",`fragmentid` INT UNSIGNED COMMENT \"Fragment id\",`op` INT UNSIGNED COMMENT \"Operation type\",`state` INT UNSIGNED "
  "COMMENT \"Operation state\",`flags` INT UNSIGNED COMMENT \"Operation flags\") COMMENT=\"operations\" ENGINE=NDBINFO C"
  "HARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$pools`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$pools` (`node_id` INT UNSIGNED,`block_number` INT UNSIGNED,`block"
  "_instance` INT UNSIGNED,`pool_name` VARCHAR(512),`used` BIGINT UNSIGNED COMMENT \"currently in use\",`total` BIGINT U"
  "NSIGNED COMMENT \"total allocated\",`high` BIGINT UNSIGNED COMMENT \"in use high water mark\",`entry_size` BIGINT UNS"
  "IGNED COMMENT \"size in bytes of each object\",`config_param1` INT UNSIGNED COMMENT \"config param 1 affecting pool\""
  ",`config_param2` INT UNSIGNED COMMENT \"config param 2 affecting pool\",`config_param3` INT UNSIGNED COMMENT \"config"
  " param 3 affecting pool\",`config_param4` INT UNSIGNED COMMENT \"config param 4 affecting pool\",`resource_id` INT UN"
  "SIGNED,`type_id` INT UNSIGNED COMMENT \"Record type id within resource\") COMMENT=\"pool usage\" ENGINE=NDBINFO CHARA"
  "CTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$processes`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$processes` (`reporting_node_id` INT UNSIGNED COMMENT \"Reporting "
  "data node ID\",`node_id` INT UNSIGNED COMMENT \"Connected node ID\",`node_type` INT UNSIGNED COMMENT \"Type of node\""
  ",`node_version` VARCHAR(512) COMMENT \"Node MySQL Cluster version string\",`process_id` INT UNSIGNED COMMENT \"PID of"
  " node process on host\",`angel_process_id` INT UNSIGNED COMMENT \"PID of node\\'s angel process\",`process_name` VARCH"
  "AR(512) COMMENT \"Node\\'s executable process name\",`service_URI` VARCHAR(512) COMMENT \"URI for service provided by "
  "node\") COMMENT=\"Process ID and Name information for connected nodes\" ENGINE=NDBINFO CHARACTER SET latin1','SET @du"
  "mmy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$resources`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$resources` (`node_id` INT UNSIGNED,`resource_id` INT UNSIGNED,`re"
  "served` INT UNSIGNED COMMENT \"reserved for this resource\",`used` INT UNSIGNED COMMENT \"currently in use\",`max` IN"
  "T UNSIGNED COMMENT \"max available\",`high` INT UNSIGNED COMMENT \"in use high water mark\",`spare` INT UNSIGNED COMM"
  "ENT \"spare pages for restart\") COMMENT=\"resources usage (a.k.a superpool)\" ENGINE=NDBINFO CHARACTER SET latin1','"
  "SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$restart_info`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$restart_info` (`node_id` INT UNSIGNED COMMENT \"node id\",`node_r"
  "estart_status` VARCHAR(512) COMMENT \"Current state of node recovery\",`node_restart_status_int` INT UNSIGNED COMMENT"
  " \"Current state of node recovery as number\",`secs_to_complete_node_failure` INT UNSIGNED COMMENT \"Seconds to compl"
  "ete node failure handling\",`secs_to_allocate_node_id` INT UNSIGNED COMMENT \"Seconds from node failure completion to"
  " allocation of node id\",`secs_to_include_in_heartbeat_protocol` INT UNSIGNED COMMENT \"Seconds from allocation of no"
  "de id to inclusion in HB protocol\",`secs_until_wait_for_ndbcntr_master` INT UNSIGNED COMMENT \"Seconds from included"
  " in HB protocol until we wait for ndbcntr master\",`secs_wait_for_ndbcntr_master` INT UNSIGNED COMMENT \"Seconds we w"
  "aited for being accepted by NDBCNTR master to start\",`secs_to_get_start_permitted` INT UNSIGNED COMMENT \"Seconds fr"
  "om permit by master until all nodes accepted our start\",`secs_to_wait_for_lcp_for_copy_meta_data` INT UNSIGNED COMME"
  "NT \"Seconds waiting for LCP completion before copying meta data\",`secs_to_copy_meta_data` INT UNSIGNED COMMENT \"Se"
  "conds to copy meta data to starting node from master\",`secs_to_include_node` INT UNSIGNED COMMENT \"Seconds to wait "
  "for GCP and inclusion of all nodes into protocols\",`secs_starting_node_to_request_local_recovery` INT UNSIGNED COMME"
  "NT \"Seconds for starting node to request local recovery\",`secs_for_local_recovery` INT UNSIGNED COMMENT \"Seconds f"
  "or local recovery in starting node\",`secs_restore_fragments` INT UNSIGNED COMMENT \"Seconds to restore fragments fro"
  "m LCP files\",`secs_undo_disk_data` INT UNSIGNED COMMENT \"Seconds to execute UNDO log on disk data part of records\""
  ",`secs_exec_redo_log` INT UNSIGNED COMMENT \"Seconds to execute REDO log on all restored fragments\",`secs_index_rebu"
  "ild` INT UNSIGNED COMMENT \"Seconds to rebuild indexes on restored fragments\",`secs_to_synchronize_starting_node` IN"
  "T UNSIGNED COMMENT \"Seconds to synchronize starting node from live nodes\",`secs_wait_lcp_for_restart` INT UNSIGNED "
  "COMMENT \"Seconds to wait for LCP start and completion before restart is completed\",`secs_wait_subscription_handover"
  "` INT UNSIGNED COMMENT \"Seconds waiting for handover of replication subscriptions\",`total_restart_secs` INT UNSIGNE"
  "D COMMENT \"Total number of seconds from node failure until node is started again\") COMMENT=\"Times of restart phase"
  "s in seconds and current state\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$stored_tables`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$stored_tables` (`node_id` INT UNSIGNED COMMENT \"node_id\",`table"
  "_id` INT UNSIGNED COMMENT \"Table id\",`logged_table` INT UNSIGNED COMMENT \"Is table logged\",`row_contains_gci` INT"
  " UNSIGNED COMMENT \"Does table rows contains GCI\",`row_contains_checksum` INT UNSIGNED COMMENT \"Does table rows con"
  "tain checksum\",`temporary_table` INT UNSIGNED COMMENT \"Is table temporary\",`force_var_part` INT UNSIGNED COMMENT \""
  "Force var part active\",`read_backup` INT UNSIGNED COMMENT \"Is backup replicas read\",`fully_replicated` INT UNSIGNE"
  "D COMMENT \"Is table fully replicated\",`extra_row_gci` INT UNSIGNED COMMENT \"extra_row_gci\",`extra_row_author` INT"
  " UNSIGNED COMMENT \"extra_row_author\",`storage_type` INT UNSIGNED COMMENT \"Storage type of table\",`hashmap_id` INT"
  " UNSIGNED COMMENT \"Hashmap id\",`hashmap_version` INT UNSIGNED COMMENT \"Hashmap version\",`table_version` INT UNSIG"
  "NED COMMENT \"Table version\",`fragment_type` INT UNSIGNED COMMENT \"Type of fragmentation\",`partition_balance` INT "
  "UNSIGNED COMMENT \"Partition balance\",`create_gci` INT UNSIGNED COMMENT \"GCI in which table was created\",`backup_l"
  "ocked` INT UNSIGNED COMMENT \"Locked for backup\",`single_user_mode` INT UNSIGNED COMMENT \"Is single user mode activ"
  "e\") COMMENT=\"Information about stored tables\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$table_distribution_status`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$table_distribution_status` (`node_id` INT UNSIGNED COMMENT \"Node"
  " id\",`table_id` INT UNSIGNED COMMENT \"Table id\",`tab_copy_status` INT UNSIGNED COMMENT \"Copy status of the table\""
  ",`tab_update_status` INT UNSIGNED COMMENT \"Update status of the table\",`tab_lcp_status` INT UNSIGNED COMMENT \"LCP "
  "status of the table\",`tab_status` INT UNSIGNED COMMENT \"Create status of the table\",`tab_storage` INT UNSIGNED COM"
  "MENT \"Storage type of table\",`tab_type` INT UNSIGNED COMMENT \"Type of table\",`tab_partitions` INT UNSIGNED COMMEN"
  "T \"Number of partitions in table\",`tab_fragments` INT UNSIGNED COMMENT \"Number of fragments in table\",`current_sc"
  "an_count` INT UNSIGNED COMMENT \"Current number of active scans\",`scan_count_wait` INT UNSIGNED COMMENT \"Number of "
  "scans waiting for\",`is_reorg_ongoing` INT UNSIGNED COMMENT \"Is a table reorg ongoing on table\") COMMENT=\"Table st"
  "atus in distribution handler\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$table_distribution_status_all`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$table_distribution_status_all` (`node_id` INT UNSIGNED COMMENT \""
  "Node id\",`table_id` INT UNSIGNED COMMENT \"Table id\",`tab_copy_status` INT UNSIGNED COMMENT \"Copy status of the ta"
  "ble\",`tab_update_status` INT UNSIGNED COMMENT \"Update status of the table\",`tab_lcp_status` INT UNSIGNED COMMENT \""
  "LCP status of the table\",`tab_status` INT UNSIGNED COMMENT \"Create status of the table\",`tab_storage` INT UNSIGNED"
  " COMMENT \"Storage type of table\",`tab_type` INT UNSIGNED COMMENT \"Type of table\",`tab_partitions` INT UNSIGNED CO"
  "MMENT \"Number of partitions in table\",`tab_fragments` INT UNSIGNED COMMENT \"Number of fragments in table\",`curren"
  "t_scan_count` INT UNSIGNED COMMENT \"Current number of active scans\",`scan_count_wait` INT UNSIGNED COMMENT \"Number"
  " of scans waiting for\",`is_reorg_ongoing` INT UNSIGNED COMMENT \"Is a table reorg ongoing on table\") COMMENT=\"Tabl"
  "e status in distribution handler\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$table_fragments`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$table_fragments` (`node_id` INT UNSIGNED COMMENT \"node_id\",`tab"
  "le_id` INT UNSIGNED COMMENT \"Table id\",`partition_id` INT UNSIGNED COMMENT \"Partition id\",`fragment_id` INT UNSIG"
  "NED COMMENT \"Fragment id\",`partition_order` INT UNSIGNED COMMENT \"Order of fragment in partition\",`log_part_id` I"
  "NT UNSIGNED COMMENT \"Log part id of fragment\",`no_of_replicas` INT UNSIGNED COMMENT \"Number of replicas\",`current"
  "_primary` INT UNSIGNED COMMENT \"Current primary node id\",`preferred_primary` INT UNSIGNED COMMENT \"Preferred prima"
  "ry node id\",`current_first_backup` INT UNSIGNED COMMENT \"Current first backup node id\",`current_second_backup` INT"
  " UNSIGNED COMMENT \"Current second backup node id\",`current_third_backup` INT UNSIGNED COMMENT \"Current third backu"
  "p node id\",`num_alive_replicas` INT UNSIGNED COMMENT \"Current number of alive replicas\",`num_dead_replicas` INT UN"
  "SIGNED COMMENT \"Current number of dead replicas\",`num_lcp_replicas` INT UNSIGNED COMMENT \"Number of replicas remai"
  "ning to be LCP:ed\") COMMENT=\"Partitions of the tables\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$table_fragments_all`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$table_fragments_all` (`node_id` INT UNSIGNED COMMENT \"node_id\","
  "`table_id` INT UNSIGNED COMMENT \"Table id\",`partition_id` INT UNSIGNED COMMENT \"Partition id\",`fragment_id` INT U"
  "NSIGNED COMMENT \"Fragment id\",`partition_order` INT UNSIGNED COMMENT \"Order of fragment in partition\",`log_part_i"
  "d` INT UNSIGNED COMMENT \"Log part id of fragment\",`no_of_replicas` INT UNSIGNED COMMENT \"Number of replicas\",`cur"
  "rent_primary` INT UNSIGNED COMMENT \"Current primary node id\",`preferred_primary` INT UNSIGNED COMMENT \"Preferred p"
  "rimary node id\",`current_first_backup` INT UNSIGNED COMMENT \"Current first backup node id\",`current_second_backup`"
  " INT UNSIGNED COMMENT \"Current second backup node id\",`current_third_backup` INT UNSIGNED COMMENT \"Current third b"
  "ackup node id\",`num_alive_replicas` INT UNSIGNED COMMENT \"Current number of alive replicas\",`num_dead_replicas` IN"
  "T UNSIGNED COMMENT \"Current number of dead replicas\",`num_lcp_replicas` INT UNSIGNED COMMENT \"Number of replicas r"
  "emaining to be LCP:ed\") COMMENT=\"Partitions of the tables\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$table_replicas`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$table_replicas` (`node_id` INT UNSIGNED COMMENT \"node_id\",`tabl"
  "e_id` INT UNSIGNED COMMENT \"Table id\",`fragment_id` INT UNSIGNED COMMENT \"Fragment id\",`initial_gci` INT UNSIGNED"
  " COMMENT \"Initial GCI for table\",`replica_node_id` INT UNSIGNED COMMENT \"Node id where replica is stored\",`is_lcp"
  "_ongoing` INT UNSIGNED COMMENT \"Is LCP ongoing on this fragment\",`num_crashed_replicas` INT UNSIGNED COMMENT \"Numb"
  "er of crashed replica instances\",`last_max_gci_started` INT UNSIGNED COMMENT \"Last LCP Max GCI started\",`last_max_"
  "gci_completed` INT UNSIGNED COMMENT \"Last LCP Max GCI completed\",`last_lcp_id` INT UNSIGNED COMMENT \"Last LCP id\""
  ",`prev_lcp_id` INT UNSIGNED COMMENT \"Previous LCP id\",`prev_max_gci_started` INT UNSIGNED COMMENT \"Previous LCP Ma"
  "x GCI started\",`prev_max_gci_completed` INT UNSIGNED COMMENT \"Previous LCP Max GCI completed\",`last_create_gci` IN"
  "T UNSIGNED COMMENT \"Last Create GCI of last crashed replica instance\",`last_replica_gci` INT UNSIGNED COMMENT \"Las"
  "t GCI of last crashed replica instance\",`is_replica_alive` INT UNSIGNED COMMENT \"Is replica alive or not\") COMMENT"
  "=\"Fragment replicas of the tables\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$table_replicas_all`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$table_replicas_all` (`node_id` INT UNSIGNED COMMENT \"node_id\",`"
  "table_id` INT UNSIGNED COMMENT \"Table id\",`fragment_id` INT UNSIGNED COMMENT \"Fragment id\",`initial_gci` INT UNSI"
  "GNED COMMENT \"Initial GCI for table\",`replica_node_id` INT UNSIGNED COMMENT \"Node id where replica is stored\",`is"
  "_lcp_ongoing` INT UNSIGNED COMMENT \"Is LCP ongoing on this fragment\",`num_crashed_replicas` INT UNSIGNED COMMENT \""
  "Number of crashed replica instances\",`last_max_gci_started` INT UNSIGNED COMMENT \"Last LCP Max GCI started\",`last_"
  "max_gci_completed` INT UNSIGNED COMMENT \"Last LCP Max GCI completed\",`last_lcp_id` INT UNSIGNED COMMENT \"Last LCP "
  "id\",`prev_lcp_id` INT UNSIGNED COMMENT \"Previous LCP id\",`prev_max_gci_started` INT UNSIGNED COMMENT \"Previous LC"
  "P Max GCI started\",`prev_max_gci_completed` INT UNSIGNED COMMENT \"Previous LCP Max GCI completed\",`last_create_gci"
  "` INT UNSIGNED COMMENT \"Last Create GCI of last crashed replica instance\",`last_replica_gci` INT UNSIGNED COMMENT \""
  "Last GCI of last crashed replica instance\",`is_replica_alive` INT UNSIGNED COMMENT \"Is replica alive or not\") COMM"
  "ENT=\"Fragment replicas of the tables\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$tables`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$tables` (`table_id` INT UNSIGNED,`table_name` VARCHAR(512),`comme"
  "nt` VARCHAR(512)) COMMENT=\"metadata for tables available through ndbinfo\" ENGINE=NDBINFO CHARACTER SET latin1','SET"
  " @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$tc_time_track_stats`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$tc_time_track_stats` (`node_id` INT UNSIGNED COMMENT \"node id\","
  "`block_number` INT UNSIGNED COMMENT \"Block number\",`block_instance` INT UNSIGNED COMMENT \"Block instance\",`comm_n"
  "ode_id` INT UNSIGNED COMMENT \"node_id of API or DB\",`upper_bound` BIGINT UNSIGNED COMMENT \"Upper bound in micros o"
  "f interval\",`scans` BIGINT UNSIGNED COMMENT \"scan histogram interval\",`scan_errors` BIGINT UNSIGNED COMMENT \"scan"
  " error histogram interval\",`scan_fragments` BIGINT UNSIGNED COMMENT \"scan fragment histogram interval\",`scan_fragm"
  "ent_errors` BIGINT UNSIGNED COMMENT \"scan fragment error histogram interval\",`transactions` BIGINT UNSIGNED COMMENT"
  " \"transaction histogram interval\",`transaction_errors` BIGINT UNSIGNED COMMENT \"transaction error histogram interv"
  "al\",`read_key_ops` BIGINT UNSIGNED COMMENT \"read key operation histogram interval\",`write_key_ops` BIGINT UNSIGNED"
  " COMMENT \"write key operation histogram interval\",`index_key_ops` BIGINT UNSIGNED COMMENT \"index key operation his"
  "togram interval\",`key_op_errors` BIGINT UNSIGNED COMMENT \"key operation error histogram interval\") COMMENT=\"Time "
  "tracking of transaction, key operations and scan ops\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$test`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$test` (`node_id` INT UNSIGNED,`block_number` INT UNSIGNED,`block_"
  "instance` INT UNSIGNED,`counter` INT UNSIGNED,`counter2` BIGINT UNSIGNED) COMMENT=\"for testing\" ENGINE=NDBINFO CHAR"
  "ACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$threadblocks`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$threadblocks` (`node_id` INT UNSIGNED COMMENT \"node id\",`thr_no"
  "` INT UNSIGNED COMMENT \"thread number\",`block_number` INT UNSIGNED COMMENT \"block number\",`block_instance` INT UN"
  "SIGNED COMMENT \"block instance\") COMMENT=\"which blocks are run in which threads\" ENGINE=NDBINFO CHARACTER SET lat"
  "in1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$threads`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$threads` (`node_id` INT UNSIGNED COMMENT \"node_id\",`thr_no` INT"
  " UNSIGNED COMMENT \"thread number\",`thread_name` VARCHAR(512) COMMENT \"thread_name\",`thread_description` VARCHAR(5"
  "12) COMMENT \"thread_description\") COMMENT=\"Base table for threads\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dum"
  "my = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$threadstat`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$threadstat` (`node_id` INT UNSIGNED COMMENT \"node id\",`thr_no` "
  "INT UNSIGNED COMMENT \"thread number\",`thr_nm` VARCHAR(512) COMMENT \"thread name\",`c_loop` BIGINT UNSIGNED COMMENT"
  " \"No of loops in main loop\",`c_exec` BIGINT UNSIGNED COMMENT \"No of signals executed\",`c_wait` BIGINT UNSIGNED CO"
  "MMENT \"No of times waited for more input\",`c_l_sent_prioa` BIGINT UNSIGNED COMMENT \"No of prio A signals sent to o"
  "wn node\",`c_l_sent_priob` BIGINT UNSIGNED COMMENT \"No of prio B signals sent to own node\",`c_r_sent_prioa` BIGINT "
  "UNSIGNED COMMENT \"No of prio A signals sent to remote node\",`c_r_sent_priob` BIGINT UNSIGNED COMMENT \"No of prio B"
  " signals sent to remote node\",`os_tid` BIGINT UNSIGNED COMMENT \"OS thread id\",`os_now` BIGINT UNSIGNED COMMENT \"O"
  "S gettimeofday (millis)\",`os_ru_utime` BIGINT UNSIGNED COMMENT \"OS user CPU time (micros)\",`os_ru_stime` BIGINT UN"
  "SIGNED COMMENT \"OS system CPU time (micros)\",`os_ru_minflt` BIGINT UNSIGNED COMMENT \"OS page reclaims (soft page f"
  "aults\",`os_ru_majflt` BIGINT UNSIGNED COMMENT \"OS page faults (hard page faults)\",`os_ru_nvcsw` BIGINT UNSIGNED CO"
  "MMENT \"OS voluntary context switches\",`os_ru_nivcsw` BIGINT UNSIGNED COMMENT \"OS involuntary context switches\") C"
  "OMMENT=\"Statistics on execution threads\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$transactions`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$transactions` (`node_id` INT UNSIGNED COMMENT \"node id\",`block_"
  "instance` INT UNSIGNED COMMENT \"TC instance no\",`objid` INT UNSIGNED COMMENT \"Object id of transaction object\",`a"
  "piref` INT UNSIGNED COMMENT \"API reference\",`transid0` INT UNSIGNED COMMENT \"Transaction id\",`transid1` INT UNSIG"
  "NED COMMENT \"Transaction id\",`state` INT UNSIGNED COMMENT \"Transaction state\",`flags` INT UNSIGNED COMMENT \"Tran"
  "saction flags\",`c_ops` INT UNSIGNED COMMENT \"No of operations in transaction\",`outstanding` INT UNSIGNED COMMENT \""
  "Currently outstanding request\",`timer` INT UNSIGNED COMMENT \"Timer (seconds)\") COMMENT=\"transactions\" ENGINE=NDB"
  "INFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$transporters`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$transporters` (`node_id` INT UNSIGNED COMMENT \"Node id reporting"
  "\",`remote_node_id` INT UNSIGNED COMMENT \"Node id at other end of link\",`connection_status` INT UNSIGNED COMMENT \""
  "State of inter-node link\",`remote_address` VARCHAR(512) COMMENT \"Address of remote node\",`bytes_sent` BIGINT UNSIG"
  "NED COMMENT \"Bytes sent to remote node\",`bytes_received` BIGINT UNSIGNED COMMENT \"Bytes received from remote node\""
  ",`connect_count` INT UNSIGNED COMMENT \"Number of times connected\",`overloaded` INT UNSIGNED COMMENT \"Is link repor"
  "ting overload\",`overload_count` INT UNSIGNED COMMENT \"Number of overload onsets since connect\",`slowdown` INT UNSI"
  "GNED COMMENT \"Is link requesting slowdown\",`slowdown_count` INT UNSIGNED COMMENT \"Number of slowdown onsets since "
  "connect\") COMMENT=\"transporter status\" ENGINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$blocks`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$blocks` (block_number INT UNSIGNED, block_name VARCHAR(512)) ENGI"
  "NE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$config_params`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$config_params` (param_number INT UNSIGNED, param_name VARCHAR(512"
  "), param_description VARCHAR(512), param_type VARCHAR(512), param_default VARCHAR(512), param_min VARCHAR(512), param"
  "_max VARCHAR(512), param_mandatory INT UNSIGNED, param_status VARCHAR(512)) ENGINE=NDBINFO CHARACTER SET latin1','SET"
  " @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$dblqh_tcconnect_state`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$dblqh_tcconnect_state` (state_int_value INT UNSIGNED, state_name "
  "VARCHAR(256), state_friendly_name VARCHAR(256), state_description VARCHAR(256)) ENGINE=NDBINFO CHARACTER SET latin1',"
  "'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$dbtc_apiconnect_state`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$dbtc_apiconnect_state` (state_int_value INT UNSIGNED, state_name "
  "VARCHAR(256), state_friendly_name VARCHAR(256), state_description VARCHAR(256)) ENGINE=NDBINFO CHARACTER SET latin1',"
  "'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$dict_obj_types`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$dict_obj_types` (type_id INT UNSIGNED, type_name VARCHAR(512)) EN"
  "GINE=NDBINFO CHARACTER SET latin1','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'DROP TABLE IF EXISTS `ndbinfo`.`ndb$error_messages`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE TABLE `ndbinfo`.`ndb$error_messages` (error_code INT UNSIGNED, error_description VARCH"
  "AR(512), error_status VARCHAR(512), error_classification VARCHAR(512)) ENGINE=NDBINFO CHARACTER SET latin1','SET @dum"
  "my = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`arbitrator_"
  "validity_detail` AS SELECT node_id, arbitrator, arb_ticket, CASE arb_connected  WHEN 1 THEN \"Yes\"  ELSE \"No\" END "
  "AS arb_connected, CASE arb_state  WHEN 0 THEN \"ARBIT_NULL\"  WHEN 1 THEN \"ARBIT_INIT\"  WHEN 2 THEN \"ARBIT_FIND\" "
  " WHEN 3 THEN \"ARBIT_PREP1\"  WHEN 4 THEN \"ARBIT_PREP2\"  WHEN 5 THEN \"ARBIT_START\"  WHEN 6 THEN \"ARBIT_RUN\"  WH"
  "EN 7 THEN \"ARBIT_CHOOSE\"  WHEN 8 THEN \"ARBIT_CRASH\"  ELSE \"UNKNOWN\" END AS arb_state FROM `ndbinfo`.`ndb$member"
  "ship` ORDER BY arbitrator, arb_connected DESC','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`arbitrator_"
  "validity_summary` AS SELECT arbitrator, arb_ticket, CASE arb_connected  WHEN 1 THEN \"Yes\"  ELSE \"No\" END AS arb_c"
  "onnected, count(*) as consensus_count FROM `ndbinfo`.`ndb$membership` GROUP BY arbitrator, arb_ticket, arb_connected'"
  ",'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`blocks` AS "
  "SELECT block_number, block_name FROM `ndbinfo`.`ndb$blocks`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`cluster_loc"
  "ks` AS SELECT `ndbinfo`.`ndb$acc_operations`.`node_id` AS `node_id`,`ndbinfo`.`ndb$acc_operations`.`block_instance` A"
  "S `block_instance`,`ndbinfo`.`ndb$acc_operations`.`tableid` AS `tableid`,`ndbinfo`.`ndb$acc_operations`.`fragmentid` "
  "AS `fragmentid`,`ndbinfo`.`ndb$acc_operations`.`rowid` AS `rowid`,`ndbinfo`.`ndb$acc_operations`.`transid0` + (`ndbin"
  "fo`.`ndb$acc_operations`.`transid1` << 32) AS `transid`,(case (`ndbinfo`.`ndb$acc_operations`.`op_flags` & 0x10) when"
  " 0 then \"S\" else \"X\" end) AS `mode`,(case (`ndbinfo`.`ndb$acc_operations`.`op_flags` & 0x80) when 0 then \"W\" el"
  "se \"H\" end) AS `state`,(case (`ndbinfo`.`ndb$acc_operations`.`op_flags` & 0x40) when 0 then \"\" else \"*\" end) as"
  " `detail`,case (`ndbinfo`.`ndb$acc_operations`.`op_flags` & 0xf) when 0 then \"READ\" when 1 then \"UPDATE\" when 2 t"
  "hen \"INSERT\"when 3 then \"DELETE\" when 5 then \"READ\" when 6 then \"REFRESH\"when 7 then \"UNLOCK\" when 8 then \""
  "SCAN\" ELSE\"<unknown>\" END as `op`,`ndbinfo`.`ndb$acc_operations`.`duration_millis` as `duration_millis`,`ndbinfo`."
  "`ndb$acc_operations`.`acc_op_id` AS `lock_num`,if(`ndbinfo`.`ndb$acc_operations`.`op_flags` & 0xc0 = 0,`ndbinfo`.`ndb"
  "$acc_operations`.`prev_serial_op_id`, NULL) as `waiting_for` FROM `ndbinfo`.`ndb$acc_operations`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`cluster_ope"
  "rations` AS SELECT o.node_id, o.block_instance, o.transid0 + (o.transid1 << 32) as transid, case o.op  when 1 then \""
  "READ\" when 2 then \"READ-SH\" when 3 then \"READ-EX\" when 4 then \"INSERT\" when 5 then \"UPDATE\" when 6 then \"DE"
  "LETE\" when 7 then \"WRITE\" when 8 then \"UNLOCK\" when 9 then \"REFRESH\" when 257 then \"SCAN\" when 258 then \"SC"
  "AN-SH\" when 259 then \"SCAN-EX\" ELSE \"<unknown>\" END as operation_type,  s.state_friendly_name as state,  o.table"
  "id,  o.fragmentid,  (o.apiref & 65535) as client_node_id,  (o.apiref >> 16) as client_block_ref,  (o.tcref & 65535) a"
  "s tc_node_id,  ((o.tcref >> 16) & 511) as tc_block_no,  ((o.tcref >> (16 + 9)) & 127) as tc_block_instance FROM `ndbi"
  "nfo`.`ndb$operations` o LEFT JOIN `ndbinfo`.`ndb$dblqh_tcconnect_state` s        ON s.state_int_value = o.state','SET"
  " @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`cluster_tra"
  "nsactions` AS SELECT t.node_id, t.block_instance, t.transid0 + (t.transid1 << 32) as transid, s.state_friendly_name a"
  "s state,  t.c_ops as count_operations,  t.outstanding as outstanding_operations,  t.timer as inactive_seconds,  (t.ap"
  "iref & 65535) as client_node_id,  (t.apiref >> 16) as client_block_ref FROM `ndbinfo`.`ndb$transactions` t LEFT JOIN "
  "`ndbinfo`.`ndb$dbtc_apiconnect_state` s        ON s.state_int_value = t.state','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`config_node"
  "s` AS SELECT distinct node_id, CASE node_type  WHEN 0 THEN \"NDB\"  WHEN 1 THEN \"API\"  WHEN 2 THEN \"MGM\"  ELSE NU"
  "LL  END AS node_type, node_hostname FROM `ndbinfo`.`ndb$config_nodes` ORDER BY node_id','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`config_para"
  "ms` AS SELECT param_number, param_name, param_description, param_type, param_default, param_min, param_max, param_man"
  "datory, param_status FROM `ndbinfo`.`ndb$config_params`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`config_valu"
  "es` AS SELECT node_id, config_param, config_value FROM `ndbinfo`.`ndb$config_values`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`counters` A"
  "S SELECT node_id, b.block_name, block_instance, counter_id, CASE counter_id  WHEN 1 THEN \"ATTRINFO\"  WHEN 2 THEN \""
  "TRANSACTIONS\"  WHEN 3 THEN \"COMMITS\"  WHEN 4 THEN \"READS\"  WHEN 5 THEN \"SIMPLE_READS\"  WHEN 6 THEN \"WRITES\" "
  " WHEN 7 THEN \"ABORTS\"  WHEN 8 THEN \"TABLE_SCANS\"  WHEN 9 THEN \"RANGE_SCANS\"  WHEN 10 THEN \"OPERATIONS\"  WHEN "
  "11 THEN \"READS_RECEIVED\"  WHEN 12 THEN \"LOCAL_READS_SENT\"  WHEN 13 THEN \"REMOTE_READS_SENT\"  WHEN 14 THEN \"REA"
  "DS_NOT_FOUND\"  WHEN 15 THEN \"TABLE_SCANS_RECEIVED\"  WHEN 16 THEN \"LOCAL_TABLE_SCANS_SENT\"  WHEN 17 THEN \"RANGE_"
  "SCANS_RECEIVED\"  WHEN 18 THEN \"LOCAL_RANGE_SCANS_SENT\"  WHEN 19 THEN \"REMOTE_RANGE_SCANS_SENT\"  WHEN 20 THEN \"S"
  "CAN_BATCHES_RETURNED\"  WHEN 21 THEN \"SCAN_ROWS_RETURNED\"  WHEN 22 THEN \"PRUNED_RANGE_SCANS_RECEIVED\"  WHEN 23 TH"
  "EN \"CONST_PRUNED_RANGE_SCANS_RECEIVED\"  WHEN 24 THEN \"LOCAL_READS\"  WHEN 25 THEN \"LOCAL_WRITES\"  WHEN 26 THEN \""
  "LQHKEY_OVERLOAD\"  WHEN 27 THEN \"LQHKEY_OVERLOAD_TC\"  WHEN 28 THEN \"LQHKEY_OVERLOAD_READER\"  WHEN 29 THEN \"LQHKE"
  "Y_OVERLOAD_NODE_PEER\"  WHEN 30 THEN \"LQHKEY_OVERLOAD_SUBSCRIBER\"  WHEN 31 THEN \"LQHSCAN_SLOWDOWNS\"  ELSE \"<unkn"
  "own>\"  END AS counter_name, val FROM `ndbinfo`.`ndb$counters` c LEFT JOIN `ndbinfo`.`ndb$blocks` b ON c.block_number"
  " = b.block_number','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`cpustat` AS"
  " SELECT * FROM `ndbinfo`.`ndb$cpustat`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`cpustat_1se"
  "c` AS SELECT * FROM `ndbinfo`.`ndb$cpustat_1sec`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`cpustat_20s"
  "ec` AS SELECT * FROM `ndbinfo`.`ndb$cpustat_20sec`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`cpustat_50m"
  "s` AS SELECT * FROM `ndbinfo`.`ndb$cpustat_50ms`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`dict_obj_in"
  "fo` AS  SELECT * FROM `ndbinfo`.`ndb$dict_obj_info`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`dict_obj_ty"
  "pes` AS SELECT type_id, type_name FROM `ndbinfo`.`ndb$dict_obj_types`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`disk_write_"
  "speed_aggregate` AS SELECT * FROM `ndbinfo`.`ndb$disk_write_speed_aggregate`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`disk_write_"
  "speed_aggregate_node` AS SELECT node_id, SUM(backup_lcp_speed_last_sec) AS backup_lcp_speed_last_sec, SUM(redo_speed_"
  "last_sec) AS redo_speed_last_sec, SUM(backup_lcp_speed_last_10sec) AS backup_lcp_speed_last_10sec, SUM(redo_speed_las"
  "t_10sec) AS redo_speed_last_10sec, SUM(backup_lcp_speed_last_60sec) AS backup_lcp_speed_last_60sec, SUM(redo_speed_la"
  "st_60sec) AS redo_speed_last_60sec FROM `ndbinfo`.`ndb$disk_write_speed_aggregate` GROUP by node_id','SET @dummy = 0'"
  ");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`disk_write_"
  "speed_base` AS SELECT * FROM `ndbinfo`.`ndb$disk_write_speed_base`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`diskpagebuf"
  "fer` AS SELECT node_id, block_instance, pages_written, pages_written_lcp, pages_read, log_waits, page_requests_direct"
  "_return, page_requests_wait_queue, page_requests_wait_io FROM `ndbinfo`.`ndb$diskpagebuffer`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`error_messa"
  "ges` AS SELECT error_code, error_description, error_status, error_classification FROM `ndbinfo`.`ndb$error_messages`'"
  ",'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`locks_per_f"
  "ragment` AS SELECT name.fq_name, parent_name.fq_name AS parent_fq_name, types.type_name AS type, table_id, node_id, b"
  "lock_instance, fragment_num, ex_req, ex_imm_ok, ex_wait_ok, ex_wait_fail, sh_req, sh_imm_ok, sh_wait_ok, sh_wait_fail"
  ", wait_ok_millis, wait_fail_millis FROM `ndbinfo`.`ndb$frag_locks` AS locks JOIN `ndbinfo`.`ndb$dict_obj_info` AS nam"
  "e ON name.id=locks.table_id AND name.type<=6 JOIN `ndbinfo`.`ndb$dict_obj_types` AS types ON name.type=types.type_id "
  "LEFT JOIN `ndbinfo`.`ndb$dict_obj_info` AS parent_name ON name.parent_obj_id=parent_name.id AND name.parent_obj_type="
  "parent_name.type','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`logbuffers`"
  " AS SELECT node_id,  CASE log_type  WHEN 0 THEN \"REDO\"  WHEN 1 THEN \"DD-UNDO\"  WHEN 2 THEN \"BACKUP-DATA\"  WHEN "
  "3 THEN \"BACKUP-LOG\"  ELSE \"<unknown>\"  END AS log_type, log_id, log_part, total, used FROM `ndbinfo`.`ndb$logbuff"
  "ers`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`logspaces` "
  "AS SELECT node_id,  CASE log_type  WHEN 0 THEN \"REDO\"  WHEN 1 THEN \"DD-UNDO\"  ELSE NULL  END AS log_type, log_id,"
  " log_part, total, used FROM `ndbinfo`.`ndb$logspaces`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`membership`"
  " AS SELECT node_id, group_id, left_node, right_node, president, successor, dynamic_id & 0xFFFF AS succession_order, d"
  "ynamic_id >> 16 AS Conf_HB_order, arbitrator, arb_ticket, CASE arb_state  WHEN 0 THEN \"ARBIT_NULL\"  WHEN 1 THEN \"A"
  "RBIT_INIT\"  WHEN 2 THEN \"ARBIT_FIND\"  WHEN 3 THEN \"ARBIT_PREP1\"  WHEN 4 THEN \"ARBIT_PREP2\"  WHEN 5 THEN \"ARBI"
  "T_START\"  WHEN 6 THEN \"ARBIT_RUN\"  WHEN 7 THEN \"ARBIT_CHOOSE\"  WHEN 8 THEN \"ARBIT_CRASH\"  ELSE \"UNKNOWN\" END"
  " AS arb_state, CASE arb_connected  WHEN 1 THEN \"Yes\"  ELSE \"No\" END AS arb_connected, conn_rank1_arbs AS connecte"
  "d_rank1_arbs, conn_rank2_arbs AS connected_rank2_arbs FROM `ndbinfo`.`ndb$membership`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`memory_per_"
  "fragment` AS SELECT name.fq_name, parent_name.fq_name AS parent_fq_name,types.type_name AS type, table_id, node_id, b"
  "lock_instance, fragment_num, fixed_elem_alloc_bytes, fixed_elem_free_bytes, fixed_elem_size_bytes, fixed_elem_count, "
  "FLOOR(fixed_elem_free_bytes/fixed_elem_size_bytes) AS fixed_elem_free_count, var_elem_alloc_bytes, var_elem_free_byte"
  "s, var_elem_count, hash_index_alloc_bytes FROM `ndbinfo`.`ndb$frag_mem_use` AS space JOIN `ndbinfo`.`ndb$dict_obj_inf"
  "o` AS name ON name.id=space.table_id AND name.type<=6 JOIN  `ndbinfo`.`ndb$dict_obj_types` AS types ON name.type=type"
  "s.type_id LEFT JOIN `ndbinfo`.`ndb$dict_obj_info` AS parent_name ON name.parent_obj_id=parent_name.id AND name.parent"
  "_obj_type=parent_name.type','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`memoryusage"
  "` AS SELECT node_id,  pool_name AS memory_type,  SUM(used*entry_size) AS used,  SUM(used) AS used_pages,  SUM(total*e"
  "ntry_size) AS total,  SUM(total) AS total_pages FROM `ndbinfo`.`ndb$pools` WHERE block_number = 254 GROUP BY node_id,"
  " memory_type','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`nodes` AS S"
  "ELECT node_id, uptime, CASE status  WHEN 0 THEN \"NOTHING\"  WHEN 1 THEN \"CMVMI\"  WHEN 2 THEN \"STARTING\"  WHEN 3 "
  "THEN \"STARTED\"  WHEN 4 THEN \"SINGLEUSER\"  WHEN 5 THEN \"STOPPING_1\"  WHEN 6 THEN \"STOPPING_2\"  WHEN 7 THEN \"S"
  "TOPPING_3\"  WHEN 8 THEN \"STOPPING_4\"  ELSE \"<unknown>\"  END AS status, start_phase, config_generation FROM `ndbi"
  "nfo`.`ndb$nodes`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`operations_"
  "per_fragment` AS SELECT name.fq_name, parent_name.fq_name AS parent_fq_name, types.type_name AS type, table_id, node_"
  "id, block_instance, fragment_num, tot_key_reads, tot_key_inserts, tot_key_updates, tot_key_writes, tot_key_deletes, t"
  "ot_key_refs, tot_key_attrinfo_bytes,tot_key_keyinfo_bytes, tot_key_prog_bytes, tot_key_inst_exec, tot_key_bytes_retur"
  "ned, tot_frag_scans, tot_scan_rows_examined, tot_scan_rows_returned, tot_scan_bytes_returned, tot_scan_prog_bytes, to"
  "t_scan_bound_bytes, tot_scan_inst_exec, tot_qd_frag_scans, conc_frag_scans,conc_qd_plain_frag_scans+conc_qd_tup_frag_"
  "scans+conc_qd_acc_frag_scans AS conc_qd_frag_scans, tot_commits FROM ndbinfo.ndb$frag_operations AS ops JOIN ndbinfo."
  "ndb$dict_obj_info AS name ON name.id=ops.table_id AND name.type<=6 JOIN `ndbinfo`.`ndb$dict_obj_types` AS types ON na"
  "me.type=types.type_id LEFT JOIN `ndbinfo`.`ndb$dict_obj_info` AS parent_name ON name.parent_obj_id=parent_name.id AND"
  " name.parent_obj_type=parent_name.type','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`processes` "
  "AS SELECT DISTINCT node_id, CASE node_type  WHEN 0 THEN \"NDB\"  WHEN 1 THEN \"API\"  WHEN 2 THEN \"MGM\"  ELSE NULL "
  " END AS node_type,  node_version,  NULLIF(process_id, 0) AS process_id,  NULLIF(angel_process_id, 0) AS angel_process"
  "_id,  process_name, service_URI FROM `ndbinfo`.`ndb$processes` ORDER BY node_id','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`resources` "
  "AS SELECT node_id,  CASE resource_id  WHEN 0 THEN \"RESERVED\"  WHEN 1 THEN \"TRANSACTION_MEMORY\"  WHEN 2 THEN \"DIS"
  "K_RECORDS\"  WHEN 3 THEN \"DATA_MEMORY\"  WHEN 4 THEN \"JOBBUFFER\"  WHEN 5 THEN \"FILE_BUFFERS\"  WHEN 6 THEN \"TRAN"
  "SPORTER_BUFFERS\"  WHEN 7 THEN \"DISK_PAGE_BUFFER\"  WHEN 8 THEN \"QUERY_MEMORY\"  WHEN 9 THEN \"SCHEMA_TRANS_MEMORY\""
  "  ELSE \"<unknown>\"  END AS resource_name, reserved, used, max, spare FROM `ndbinfo`.`ndb$resources`','SET @dummy = "
  "0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`restart_inf"
  "o` AS SELECT * FROM `ndbinfo`.`ndb$restart_info`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`server_lock"
  "s` AS SELECT map.mysql_connection_id, l.* FROM `ndbinfo`.cluster_locks l JOIN information_schema.ndb_transid_mysql_co"
  "nnection_map map ON (map.ndb_transid >> 32) = (l.transid >> 32)','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`server_oper"
  "ations` AS SELECT map.mysql_connection_id, o.* FROM `ndbinfo`.cluster_operations o JOIN information_schema.ndb_transi"
  "d_mysql_connection_map map  ON (map.ndb_transid >> 32) = (o.transid >> 32)','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`server_tran"
  "sactions` AS SELECT map.mysql_connection_id, t.*FROM information_schema.ndb_transid_mysql_connection_map map JOIN `nd"
  "binfo`.cluster_transactions t   ON (map.ndb_transid >> 32) = (t.transid >> 32)','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`table_distr"
  "ibution_status` AS SELECT node_id AS node_id, table_id AS table_id, CASE tab_copy_status WHEN 0 THEN \"IDLE\" WHEN 1 "
  "THEN \"SR_PHASE1_READ_PAGES\" WHEN 2 THEN \"SR_PHASE2_READ_TABLE\" WHEN 3 THEN \"SR_PHASE3_COPY_TABLE\" WHEN 4 THEN \""
  "REMOVE_NODE\" WHEN 5 THEN \"LCP_READ_TABLE\" WHEN 6 THEN \"COPY_TAB_REQ\" WHEN 7 THEN \"COPY_NODE_STATE\" WHEN 8 THEN"
  " \"ADD_TABLE_MASTER\" WHEN 9 THEN \"ADD_TABLE_SLAVE\" WHEN 10 THEN \"INVALIDATE_NODE_LCP\" WHEN 11 THEN \"ALTER_TABLE"
  "\" WHEN 12 THEN \"COPY_TO_SAVE\" WHEN 13 THEN \"GET_TABINFO\"  ELSE \"Invalid value\" END AS tab_copy_status, CASE ta"
  "b_update_status WHEN 0 THEN \"IDLE\" WHEN 1 THEN \"LOCAL_CHECKPOINT\" WHEN 2 THEN \"LOCAL_CHECKPOINT_QUEUED\" WHEN 3 "
  "THEN \"REMOVE_NODE\" WHEN 4 THEN \"COPY_TAB_REQ\" WHEN 5 THEN \"ADD_TABLE_MASTER\" WHEN 6 THEN \"ADD_TABLE_SLAVE\" WH"
  "EN 7 THEN \"INVALIDATE_NODE_LCP\" WHEN 8 THEN \"CALLBACK\"  ELSE \"Invalid value\" END AS tab_update_status, CASE tab"
  "_lcp_status WHEN 1 THEN \"ACTIVE\" WHEN 2 THEN \"wRITING_TO_FILE\" WHEN 3 THEN \"COMPLETED\"  ELSE \"Invalid value\" "
  "END AS tab_lcp_status, CASE tab_status WHEN 0 THEN \"IDLE\" WHEN 1 THEN \"ACTIVE\" WHEN 2 THEN \"CREATING\" WHEN 3 TH"
  "EN \"DROPPING\"  ELSE \"Invalid value\" END AS tab_status, CASE tab_storage WHEN 0 THEN \"NOLOGGING\" WHEN 1 THEN \"N"
  "ORMAL\" WHEN 2 THEN \"TEMPORARY\"  ELSE \"Invalid value\" END AS tab_storage, tab_partitions AS tab_partitions, tab_f"
  "ragments AS tab_fragments, current_scan_count AS current_scan_count, scan_count_wait AS scan_count_wait, is_reorg_ong"
  "oing AS is_reorg_ongoing FROM `ndbinfo`.`ndb$table_distribution_status`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`table_fragm"
  "ents` AS SELECT * FROM `ndbinfo`.`ndb$table_fragments`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`table_info`"
  " AS  SELECT  table_id AS table_id,  logged_table AS logged_table,  row_contains_gci AS row_contains_gci,  row_contain"
  "s_checksum AS row_contains_checksum,  read_backup AS read_backup,  fully_replicated AS fully_replicated,  CASE storag"
  "e_type WHEN 0 THEN \"MEMORY\" WHEN 1 THEN \"DISK\" WHEN 2 THEN \"MEMORY\"  ELSE \"Invalid value\" END AS storage_type"
  ", hashmap_id AS hashmap_id,  CASE partition_balance WHEN 4294967295 THEN \"SPECIFIC\" WHEN 4294967294 THEN \"FOR_RP_B"
  "Y_LDM\" WHEN 4294967293 THEN \"FOR_RA_BY_LDM\" WHEN 4294967292 THEN \"FOR_RP_BY_NODE\" WHEN 4294967291 THEN \"FOR_RA_"
  "BY_NODE\" WHEN 4294967290 THEN \"FOR_RA_BY_LDM_X_2\" WHEN 4294967289 THEN \"FOR_RA_BY_LDM_X_3\" WHEN 4294967288 THEN "
  "\"FOR_RA_BY_LDM_X_4\" ELSE \"Invalid value\" END AS partition_balance, create_gci AS create_gci FROM `ndbinfo`.`ndb$s"
  "tored_tables`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`table_repli"
  "cas` AS SELECT * FROM `ndbinfo`.`ndb$table_replicas`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`tc_time_tra"
  "ck_stats` AS SELECT * FROM `ndbinfo`.`ndb$tc_time_track_stats`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`threadblock"
  "s` AS SELECT t.node_id, t.thr_no, b.block_name, t.block_instance FROM `ndbinfo`.`ndb$threadblocks` t LEFT JOIN `ndbin"
  "fo`.`ndb$blocks` b ON t.block_number = b.block_number','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`threads` AS"
  " SELECT * FROM `ndbinfo`.`ndb$threads`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`threadstat`"
  " AS SELECT * FROM `ndbinfo`.`ndb$threadstat`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'CREATE OR REPLACE DEFINER=`root`@`localhost` SQL SECURITY INVOKER VIEW `ndbinfo`.`transporter"
  "s` AS SELECT node_id, remote_node_id,  CASE connection_status  WHEN 0 THEN \"CONNECTED\"  WHEN 1 THEN \"CONNECTING\" "
  " WHEN 2 THEN \"DISCONNECTED\"  WHEN 3 THEN \"DISCONNECTING\"  ELSE NULL  END AS status,  remote_address, bytes_sent, "
  "bytes_received,  connect_count,  overloaded, overload_count, slowdown, slowdown_count FROM `ndbinfo`.`ndb$transporter"
  "s`','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_ndbinfo,'SET @@global.ndbinfo_offline=FALSE','SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @@session.sql_require_primary_key = @old_sql_require_primary_key;\n",
"set default_storage_engine=InnoDB;\n",
"SET @old_sql_mode = @@session.sql_mode, @@session.sql_mode = '';\n",
"INSERT IGNORE INTO mysql.user\n"
  "(host, user, select_priv, plugin, authentication_string, ssl_cipher, x509_issuer, x509_subject)\n"
  "VALUES ('localhost','mysql.infoschema','Y','caching_sha2_password','$A$005$THISISACOMBINATIONOFINVALIDSALTANDPASSWORD"
  "THATMUSTNEVERBRBEUSED','','','');\n",
"ALTER TABLE user add File_priv enum('N','Y') COLLATE utf8_general_ci NOT NULL;\n",
"SET @hadGrantPriv:=0;\n",
"SELECT @hadGrantPriv:=1 FROM user WHERE Grant_priv LIKE '%';\n",
"ALTER TABLE user add Grant_priv enum('N','Y') COLLATE utf8_general_ci NOT NULL,add References_priv enum('N','Y') COLLATE"
  " utf8_general_ci NOT NULL,add Index_priv enum('N','Y') COLLATE utf8_general_ci NOT NULL,add Alter_priv enum('N','Y') "
  "COLLATE utf8_general_ci NOT NULL;\n",
"ALTER TABLE db add Grant_priv enum('N','Y') COLLATE utf8_general_ci NOT NULL,add References_priv enum('N','Y') COLLATE u"
  "tf8_general_ci NOT NULL,add Index_priv enum('N','Y') COLLATE utf8_general_ci NOT NULL,add Alter_priv enum('N','Y') CO"
  "LLATE utf8_general_ci NOT NULL;\n",
"UPDATE user SET Grant_priv=File_priv,References_priv=Create_priv,Index_priv=Create_priv,Alter_priv=Create_priv WHERE @ha"
  "dGrantPriv = 0;\n",
"UPDATE db SET References_priv=Create_priv,Index_priv=Create_priv,Alter_priv=Create_priv WHERE @hadGrantPriv = 0;\n",
"ALTER TABLE user\n"
  "ADD ssl_type enum('','ANY','X509', 'SPECIFIED') COLLATE utf8_general_ci NOT NULL,\n"
  "ADD ssl_cipher BLOB NOT NULL,\n"
  "ADD x509_issuer BLOB NOT NULL,\n"
  "ADD x509_subject BLOB NOT NULL;\n",
"ALTER TABLE user MODIFY ssl_type enum('','ANY','X509', 'SPECIFIED') NOT NULL;\n",
"ALTER TABLE tables_priv\n"
  "  ADD KEY Grantor (Grantor);\n",
"ALTER TABLE tables_priv\n"
  "  MODIFY Db char(64) NOT NULL default '',\n"
  "  MODIFY User char(32) NOT NULL default '',\n"
  "  MODIFY Table_name char(64) NOT NULL default '',\n"
  "  CONVERT TO CHARACTER SET utf8 COLLATE utf8_bin;\n",
"ALTER TABLE tables_priv\n"
  "  MODIFY Column_priv set('Select','Insert','Update','References')\n"
  "    COLLATE utf8_general_ci DEFAULT '' NOT NULL,\n"
  "  MODIFY Table_priv set('Select','Insert','Update','Delete','Create',\n"
  "                        'Drop','Grant','References','Index','Alter',\n"
  "                        'Create View','Show view','Trigger')\n"
  "    COLLATE utf8_general_ci DEFAULT '' NOT NULL,\n"
  "  COMMENT='Table privileges';\n",
"ALTER TABLE columns_priv\n"
  "  CHANGE Type Column_priv set('Select','Insert','Update','References')\n"
  "    COLLATE utf8_general_ci DEFAULT '' NOT NULL;\n",
"ALTER TABLE columns_priv\n"
  "  MODIFY Db char(64) NOT NULL default '',\n"
  "  MODIFY User char(32) NOT NULL default '',\n"
  "  MODIFY Table_name char(64) NOT NULL default '',\n"
  "  MODIFY Column_name char(64) NOT NULL default '',\n"
  "  CONVERT TO CHARACTER SET utf8 COLLATE utf8_bin,\n"
  "  COMMENT='Column privileges';\n",
"ALTER TABLE columns_priv\n"
  "  MODIFY Column_priv set('Select','Insert','Update','References')\n"
  "    COLLATE utf8_general_ci DEFAULT '' NOT NULL;\n",
"ALTER TABLE func add type enum ('function','aggregate') COLLATE utf8_general_ci NOT NULL;\n",
"SET @hadShowDbPriv:=0;\n",
"SELECT @hadShowDbPriv:=1 FROM user WHERE Show_db_priv LIKE '%';\n",
"ALTER TABLE user\n"
  "ADD Show_db_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Alter_priv,\n"
  "ADD Super_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Show_db_priv,\n"
  "ADD Create_tmp_table_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Super_priv,\n"
  "ADD Lock_tables_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Create_tmp_table_priv,\n"
  "ADD Execute_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Lock_tables_priv,\n"
  "ADD Repl_slave_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Execute_priv,\n"
  "ADD Repl_client_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Repl_slave_priv;\n",
"UPDATE user SET Show_db_priv= Select_priv, Super_priv=Process_priv, Execute_priv=Process_priv, Create_tmp_table_priv='Y'"
  ", Lock_tables_priv='Y', Repl_slave_priv=file_priv, Repl_client_priv=File_priv where user<>\"\" AND @hadShowDbPriv = 0"
  ";\n",
"ALTER TABLE user\n"
  "ADD max_questions int(11) NOT NULL DEFAULT 0 AFTER x509_subject,\n"
  "ADD max_updates   int(11) unsigned NOT NULL DEFAULT 0 AFTER max_questions,\n"
  "ADD max_connections int(11) unsigned NOT NULL DEFAULT 0 AFTER max_updates;\n",
"ALTER TABLE proxies_priv MODIFY User char(32) binary DEFAULT '' NOT NULL;\n",
"ALTER TABLE proxies_priv MODIFY Proxied_user char(32) binary DEFAULT '' NOT NULL;\n",
"ALTER TABLE proxies_priv MODIFY Host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL, ENGINE=InnoDB;\n",
"ALTER TABLE proxies_priv MODIFY Proxied_host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL;\n",
"ALTER TABLE proxies_priv MODIFY Grantor varchar(288) binary DEFAULT '' NOT NULL;\n",
"ALTER TABLE db\n"
  "ADD Create_tmp_table_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "ADD Lock_tables_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL;\n",
"alter table user change max_questions max_questions int(11) unsigned DEFAULT 0  NOT NULL;\n",
"alter table db comment='Database privileges';\n",
"alter table user comment='Users and global privileges';\n",
"alter table func comment='User defined functions';\n",
"ALTER TABLE user\n"
  "  MODIFY User char(32) NOT NULL default '',\n"
  "  CONVERT TO CHARACTER SET utf8 COLLATE utf8_bin;\n",
"ALTER TABLE user\n"
  "  MODIFY Select_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Insert_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Update_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Delete_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Create_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Drop_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Reload_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Shutdown_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Process_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY File_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Grant_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY References_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Index_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Alter_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Show_db_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Super_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Create_tmp_table_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Lock_tables_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Execute_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Repl_slave_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY Repl_client_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY ssl_type enum('','ANY','X509', 'SPECIFIED') COLLATE utf8_general_ci DEFAULT '' NOT NULL;\n",
"ALTER TABLE db\n"
  "  MODIFY Db char(64) NOT NULL default '',\n"
  "  MODIFY User char(32) NOT NULL default '',\n"
  "  CONVERT TO CHARACTER SET utf8 COLLATE utf8_bin;\n",
"ALTER TABLE db\n"
  "  MODIFY  Select_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY  Insert_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY  Update_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY  Delete_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY  Create_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY  Drop_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY  Grant_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY  References_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY  Index_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY  Alter_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY  Create_tmp_table_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL,\n"
  "  MODIFY  Lock_tables_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL;\n",
"ALTER TABLE func CONVERT TO CHARACTER SET utf8 COLLATE utf8_bin;\n",
"ALTER TABLE func\n"
  "  MODIFY type enum ('function','aggregate') COLLATE utf8_general_ci NOT NULL;\n",
"SET @old_log_state = @@global.general_log;\n",
"SET GLOBAL general_log = 'OFF';\n",
"SET @old_sql_require_primary_key = @@session.sql_require_primary_key;\n",
"SET @@session.sql_require_primary_key = 0;\n",
"ALTER TABLE general_log\n"
  "  MODIFY event_time TIMESTAMP(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6),\n"
  "  MODIFY user_host MEDIUMTEXT NOT NULL,\n"
  "  MODIFY thread_id INTEGER NOT NULL,\n"
  "  MODIFY server_id INTEGER UNSIGNED NOT NULL,\n"
  "  MODIFY command_type VARCHAR(64) NOT NULL,\n"
  "  MODIFY argument MEDIUMBLOB NOT NULL;\n",
"ALTER TABLE general_log\n"
  "  MODIFY thread_id BIGINT(21) UNSIGNED NOT NULL;\n",
"SET GLOBAL general_log = @old_log_state;\n",
"SET @old_log_state = @@global.slow_query_log;\n",
"SET GLOBAL slow_query_log = 'OFF';\n",
"ALTER TABLE slow_log\n"
  "  MODIFY start_time TIMESTAMP(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6),\n"
  "  MODIFY user_host MEDIUMTEXT NOT NULL,\n"
  "  MODIFY query_time TIME(6) NOT NULL,\n"
  "  MODIFY lock_time TIME(6) NOT NULL,\n"
  "  MODIFY rows_sent INTEGER NOT NULL,\n"
  "  MODIFY rows_examined INTEGER NOT NULL,\n"
  "  MODIFY db VARCHAR(512) NOT NULL,\n"
  "  MODIFY last_insert_id INTEGER NOT NULL,\n"
  "  MODIFY insert_id INTEGER NOT NULL,\n"
  "  MODIFY server_id INTEGER UNSIGNED NOT NULL,\n"
  "  MODIFY sql_text MEDIUMBLOB NOT NULL;\n",
"ALTER TABLE slow_log\n"
  "  ADD COLUMN thread_id INTEGER NOT NULL AFTER sql_text;\n",
"ALTER TABLE slow_log\n"
  "  MODIFY thread_id BIGINT(21) UNSIGNED NOT NULL;\n",
"SET GLOBAL slow_query_log = @old_log_state;\n",
"SET @@session.sql_require_primary_key = @old_sql_require_primary_key;\n",
"ALTER TABLE plugin\n"
  "  MODIFY name varchar(64) COLLATE utf8_general_ci NOT NULL DEFAULT '',\n"
  "  MODIFY dl varchar(128) COLLATE utf8_general_ci NOT NULL DEFAULT '',\n"
  "  CONVERT TO CHARACTER SET utf8 COLLATE utf8_general_ci;\n",
"SET @hadCreateViewPriv:=0;\n",
"SELECT @hadCreateViewPriv:=1 FROM user WHERE Create_view_priv LIKE '%';\n",
"ALTER TABLE db ADD Create_view_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Lock_tables_priv;\n",
"ALTER TABLE db MODIFY Create_view_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Lock_tables_priv"
  ";\n",
"ALTER TABLE user ADD Create_view_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Repl_client_priv;\n",
"ALTER TABLE user MODIFY Create_view_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Repl_client_pr"
  "iv;\n",
"ALTER TABLE db ADD Show_view_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Create_view_priv;\n",
"ALTER TABLE db MODIFY Show_view_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Create_view_priv;\n",
"ALTER TABLE user ADD Show_view_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Create_view_priv;\n",
"ALTER TABLE user MODIFY Show_view_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Create_view_priv"
  ";\n",
"UPDATE user SET Create_view_priv=Create_priv, Show_view_priv=Create_priv where user<>\"\" AND @hadCreateViewPriv = 0;\n",
"SET @hadCreateRoutinePriv:=0;\n",
"SELECT @hadCreateRoutinePriv:=1 FROM user WHERE Create_routine_priv LIKE '%';\n",
"ALTER TABLE db ADD Create_routine_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Show_view_priv;\n",
"ALTER TABLE db MODIFY Create_routine_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Show_view_pri"
  "v;\n",
"ALTER TABLE user ADD Create_routine_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Show_view_priv"
  ";\n",
"ALTER TABLE user MODIFY Create_routine_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Show_view_p"
  "riv;\n",
"ALTER TABLE db ADD Alter_routine_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Create_routine_pr"
  "iv;\n",
"ALTER TABLE db MODIFY Alter_routine_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Create_routine"
  "_priv;\n",
"ALTER TABLE user ADD Alter_routine_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Create_routine_"
  "priv;\n",
"ALTER TABLE user MODIFY Alter_routine_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Create_routi"
  "ne_priv;\n",
"ALTER TABLE db ADD Execute_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Alter_routine_priv;\n",
"ALTER TABLE db MODIFY Execute_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Alter_routine_priv;\n",
"UPDATE user SET Create_routine_priv=Create_priv, Alter_routine_priv=Alter_priv where user<>\"\" AND @hadCreateRoutinePri"
  "v = 0;\n",
"UPDATE db SET Create_routine_priv=Create_priv, Alter_routine_priv=Alter_priv, Execute_priv=Select_priv where user<>\"\" "
  "AND @hadCreateRoutinePriv = 0;\n",
"ALTER TABLE user ADD max_user_connections int(11) unsigned DEFAULT '0' NOT NULL AFTER max_connections;\n",
"SET @hadCreateUserPriv:=0;\n",
"SELECT @hadCreateUserPriv:=1 FROM user WHERE Create_user_priv LIKE '%';\n",
"ALTER TABLE user ADD Create_user_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Alter_routine_pri"
  "v;\n",
"ALTER TABLE user MODIFY Create_user_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Alter_routine_"
  "priv;\n",
"UPDATE user LEFT JOIN db USING (Host,User) SET Create_user_priv='Y'\n"
  "  WHERE @hadCreateUserPriv = 0 AND\n"
  "        (user.Grant_priv = 'Y' OR db.Grant_priv = 'Y');\n",
"ALTER TABLE procs_priv\n"
  "  MODIFY User char(32) NOT NULL default '',\n"
  "  CONVERT TO CHARACTER SET utf8 COLLATE utf8_bin;\n",
"ALTER TABLE procs_priv\n"
  "  MODIFY Proc_priv set('Execute','Alter Routine','Grant')\n"
  "    COLLATE utf8_general_ci DEFAULT '' NOT NULL;\n",
"ALTER TABLE procs_priv\n"
  "  MODIFY Routine_name char(64)\n"
  "    COLLATE utf8_general_ci DEFAULT '' NOT NULL;\n",
"ALTER TABLE procs_priv\n"
  "  ADD Routine_type enum('FUNCTION','PROCEDURE')\n"
  "    COLLATE utf8_general_ci NOT NULL AFTER Routine_name;\n",
"ALTER TABLE procs_priv\n"
  "  MODIFY Timestamp timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP AFTER Proc_priv;\n",
"SET @hadEventPriv := 0;\n",
"SELECT @hadEventPriv :=1 FROM user WHERE Event_priv LIKE '%';\n",
"ALTER TABLE user add Event_priv enum('N','Y') character set utf8 DEFAULT 'N' NOT NULL AFTER Create_user_priv;\n",
"ALTER TABLE user MODIFY Event_priv enum('N','Y') character set utf8 DEFAULT 'N' NOT NULL AFTER Create_user_priv;\n",
"UPDATE user SET Event_priv=Super_priv WHERE @hadEventPriv = 0;\n",
"ALTER TABLE db add Event_priv enum('N','Y') character set utf8 DEFAULT 'N' NOT NULL;\n",
"ALTER TABLE db MODIFY Event_priv enum('N','Y') character set utf8 DEFAULT 'N' NOT NULL;\n",
"SET @hadTriggerPriv := 0;\n",
"SELECT @hadTriggerPriv :=1 FROM user WHERE Trigger_priv LIKE '%';\n",
"ALTER TABLE user ADD Trigger_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Event_priv;\n",
"ALTER TABLE user MODIFY Trigger_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Event_priv;\n",
"ALTER TABLE db ADD Trigger_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL;\n",
"ALTER TABLE db MODIFY Trigger_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL;\n",
"UPDATE user SET Trigger_priv=Super_priv WHERE @hadTriggerPriv = 0;\n",
"SET @hadCreateTablespacePriv := 0;\n",
"SELECT @hadCreateTablespacePriv :=1 FROM user WHERE Create_tablespace_priv LIKE '%';\n",
"ALTER TABLE user ADD Create_tablespace_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Trigger_pri"
  "v;\n",
"ALTER TABLE user MODIFY Create_tablespace_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Trigger_"
  "priv;\n",
"UPDATE user SET Create_tablespace_priv = Super_priv WHERE @hadCreateTablespacePriv = 0;\n",
"SET @global_automatic_sp_privileges = @@GLOBAL.automatic_sp_privileges;\n",
"SET GLOBAL automatic_sp_privileges = FALSE;\n",
"drop procedure if exists mysql.die;\n",
"create procedure mysql.die() signal sqlstate 'HY000' set message_text='Unexpected content found in the performance_schem"
  "a database.';\n",
"SET @cmd=\"call mysql.die()\";\n",
"SET @str = IF(@broken_pfs > 0, @cmd, 'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"drop procedure mysql.die;\n",
"SET GLOBAL automatic_sp_privileges = @global_automatic_sp_privileges;\n",
"ALTER TABLE user ADD plugin char(64) DEFAULT 'caching_sha2_password' NOT NULL,  ADD authentication_string TEXT;\n",
"ALTER TABLE user MODIFY plugin char(64) DEFAULT 'caching_sha2_password' NOT NULL;\n",
"UPDATE user SET plugin=IF((length(password) = 41), 'mysql_native_password', '') WHERE plugin = '';\n",
"UPDATE user SET plugin=IF((length(password) = 0), 'caching_sha2_password', '') WHERE plugin = '';\n",
"ALTER TABLE user MODIFY authentication_string TEXT;\n",
"SET @hadPasswordExpired:=0;\n",
"SELECT @hadPasswordExpired:=1 FROM user WHERE password_expired LIKE '%';\n",
"ALTER TABLE user ADD password_expired ENUM('N', 'Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL;\n",
"UPDATE user SET password_expired = 'N' WHERE @hadPasswordExpired=0;\n",
"ALTER TABLE user MODIFY password_expired ENUM('N', 'Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL;\n",
"SET @cmd=\"INSERT INTO proxies_priv VALUES ('localhost', 'root', '', '', TRUE, '', now())\";\n",
"SET @str = IF(@had_proxies_priv_table = 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @global_automatic_sp_privileges = @@GLOBAL.automatic_sp_privileges;\n",
"SET GLOBAL automatic_sp_privileges = FALSE;\n",
"DROP PROCEDURE IF EXISTS mysql.warn_duplicate_host_names;\n",
"CREATE PROCEDURE mysql.warn_duplicate_host_names() SIGNAL SQLSTATE '45000'  SET MESSAGE_TEXT = 'Multiple accounts exist "
  "for @user_name, @host_name that differ only in Host lettercase; remove all except one of them';\n",
"SET @cmd='call mysql.warn_duplicate_host_names()';\n",
"SET @duplicate_hosts=(SELECT count(*) FROM mysql.user GROUP BY user, lower(host) HAVING count(*) > 1 LIMIT 1);\n",
"SET @str=IF(@duplicate_hosts > 1, @cmd, 'SET @dummy=0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"SHOW WARNINGS;\n",
"DROP PREPARE stmt;\n",
"DROP PROCEDURE mysql.warn_duplicate_host_names;\n",
"SET GLOBAL automatic_sp_privileges = @global_automatic_sp_privileges;\n",
"UPDATE user SET host=LOWER( host ) WHERE LOWER( host ) <> host;\n",
"SET @have_component= (select count(*) from information_schema.tables where table_schema='mysql' and table_name='componen"
  "t');\n",
"SET @cmd=\"ALTER TABLE component ROW_FORMAT=DYNAMIC\";\n",
"SET @str = IF(@have_component = 1, @cmd, 'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @have_ndb_binlog_index= (select count(*) from information_schema.tables where table_schema='mysql' and table_name='n"
  "db_binlog_index');\n",
"SET @cmd=\"ALTER TABLE ndb_binlog_index\n"
  "  MODIFY inserts INT UNSIGNED NOT NULL,\n"
  "  MODIFY updates INT UNSIGNED NOT NULL,\n"
  "  MODIFY deletes INT UNSIGNED NOT NULL,\n"
  "  MODIFY schemaops INT UNSIGNED NOT NULL, ROW_FORMAT=DYNAMIC\";\n",
"SET @str = IF(@have_ndb_binlog_index = 1, @cmd, 'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE ndb_binlog_index\n"
  "  ADD orig_server_id INT UNSIGNED NOT NULL,\n"
  "  ADD orig_epoch BIGINT UNSIGNED NOT NULL,\n"
  "  ADD gci INT UNSIGNED NOT NULL\";\n",
"SET @str = IF(@have_ndb_binlog_index = 1, @cmd, 'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE ndb_binlog_index\n"
  "  DROP PRIMARY KEY,\n"
  "  ADD PRIMARY KEY(epoch, orig_server_id, orig_epoch)\";\n",
"SET @str = IF(@have_ndb_binlog_index = 1, @cmd, 'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @deprecated_pwds=(SELECT COUNT(*) FROM mysql.user WHERE LENGTH(password) = 16);\n",
"SET @global_automatic_sp_privileges = @@GLOBAL.automatic_sp_privileges;\n",
"SET GLOBAL automatic_sp_privileges = FALSE;\n",
"DROP PROCEDURE IF EXISTS mysql.warn_pre41_pwd;\n",
"CREATE PROCEDURE mysql.warn_pre41_pwd() SIGNAL SQLSTATE '01000' SET MESSAGE_TEXT='Pre-4.1 password hash found. It is dep"
  "recated and will be removed in a future release. Please upgrade it to a new format.';\n",
"SET @cmd='call mysql.warn_pre41_pwd()';\n",
"SET @str=IF(@deprecated_pwds > 0, @cmd, 'SET @dummy=0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"SHOW WARNINGS;\n",
"DROP PREPARE stmt;\n",
"DROP PROCEDURE mysql.warn_pre41_pwd;\n",
"SET GLOBAL automatic_sp_privileges = @global_automatic_sp_privileges;\n",
"ALTER TABLE user ADD password_last_changed timestamp NULL;\n",
"UPDATE user SET password_last_changed = CURRENT_TIMESTAMP WHERE plugin in ('caching_sha2_password','mysql_native_passwor"
  "d','sha256_password') and password_last_changed is NULL;\n",
"ALTER TABLE user ADD password_lifetime smallint unsigned NULL;\n",
"SET @hadAccountLocked:=0;\n",
"SELECT @hadAccountLocked:=1 FROM user WHERE account_locked LIKE '%';\n",
"ALTER TABLE user ADD account_locked ENUM('N', 'Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL;\n",
"UPDATE user SET account_locked = 'N' WHERE @hadAccountLocked=0;\n",
"ALTER TABLE user MODIFY account_locked ENUM('N', 'Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL;\n",
"UPDATE user SET account_locked ='Y' WHERE host = 'localhost' AND user = 'mysql.infoschema';\n",
"SET @have_password= (SELECT COUNT(*) FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'mysql'\n"
  "                    AND TABLE_NAME='user'\n"
  "                    AND column_name='password');\n",
"SET @str=IF(@have_password <> 0, \"UPDATE user SET authentication_string = password where LENGTH(password) > 0 and plugi"
  "n = 'mysql_native_password'\", \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@have_password <> 0, \"ALTER TABLE user DROP password\", \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @hadXARecoverAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'XA_RECOVER_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'XA_RECOVER_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadXARecoverAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadCloneAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'CLONE_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'CLONE_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadCloneAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadBackupAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'BACKUP_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'BACKUP_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE Reload_priv = 'Y' AND @hadBackupAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadInnodbRedoLogArchivePriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'INNODB_REDO_LOG_ARCHIVE');\n",
"INSERT INTO global_grants SELECT user, host, 'INNODB_REDO_LOG_ARCHIVE', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE Reload_priv = 'Y' AND @hadInnodbRedoLogArchivePriv = 0;\n",
"COMMIT;\n",
"SET @hadResourceGroupAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'RESOURCE_GROUP_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'RESOURCE_GROUP_ADMIN',\n"
  "IF(grant_priv = 'Y', 'Y', 'N') FROM mysql.user WHERE super_priv = 'Y' AND @hadResourceGroupAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadServiceConnectionAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'SERVICE_CONNECTION_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'SERVICE_CONNECTION_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadServiceConnectionAdminPriv = 0;\n",
"SET @hadApplicationPasswordAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'APPLICATION_PASSWORD_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'APPLICATION_PASSWORD_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE Create_user_priv = 'Y' AND @hadApplicationPasswordAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadAuditAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'AUDIT_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'AUDIT_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadAuditAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadBinLogAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'BINLOG_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'BINLOG_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadBinLogAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadBinLogEncryptionAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'BINLOG_ENCRYPTION_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'BINLOG_ENCRYPTION_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadBinLogEncryptionAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadConnectionAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'CONNECTION_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'CONNECTION_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadConnectionAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadEncryptionKeyAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'ENCRYPTION_KEY_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'ENCRYPTION_KEY_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadEncryptionKeyAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadGroupReplicationAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'GROUP_REPLICATION_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'GROUP_REPLICATION_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadGroupReplicationAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadPersistRoVariablesAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'PERSIST_RO_VARIABLES_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'PERSIST_RO_VARIABLES_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadPersistRoVariablesAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadReplicationSlaveAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'REPLICATION_SLAVE_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'REPLICATION_SLAVE_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadReplicationSlaveAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadResourceGroupUserPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'RESOURCE_GROUP_USER');\n",
"INSERT INTO global_grants SELECT user, host, 'RESOURCE_GROUP_USER', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadResourceGroupUserPriv = 0;\n",
"COMMIT;\n",
"SET @hadRoleAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'ROLE_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'ROLE_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadRoleAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadSessionVariablesAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'SESSION_VARIABLES_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'SESSION_VARIABLES_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadSessionVariablesAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadSetUserIdPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'SET_USER_ID');\n",
"INSERT INTO global_grants SELECT user, host, 'SET_USER_ID', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadSetUserIdPriv = 0;\n",
"COMMIT;\n",
"SET @hadSystemVariablesAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'SYSTEM_VARIABLES_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'SYSTEM_VARIABLES_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadSystemVariablesAdminPriv = 0;\n",
"COMMIT;\n",
"SET @hadSystemUserPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'SYSTEM_USER');\n",
"INSERT INTO global_grants SELECT user, host, 'SYSTEM_USER',\n"
  "IF (WITH_GRANT_OPTION = 'Y', 'Y', 'N') FROM global_grants WHERE priv = 'SET_USER_ID' AND @hadSystemUserPriv = 0;\n",
"COMMIT;\n",
"SET @hadSystemUserPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'SYSTEM_USER');\n",
"INSERT INTO global_grants SELECT user, host, 'SYSTEM_USER', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadSystemUserPriv = 0;\n",
"COMMIT;\n",
"SET @hadTableEncryptionAdminPriv = (SELECT COUNT(*) FROM global_grants WHERE priv = 'TABLE_ENCRYPTION_ADMIN');\n",
"INSERT INTO global_grants SELECT user, host, 'TABLE_ENCRYPTION_ADMIN', IF(grant_priv = 'Y', 'Y', 'N')\n"
  "FROM mysql.user WHERE super_priv = 'Y' AND @hadTableEncryptionAdminPriv = 0;\n",
"COMMIT;\n",
"ALTER TABLE slave_master_info ADD Ssl_crl TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The file used for the Certif"
  "icate Revocation List (CRL)';\n",
"ALTER TABLE slave_master_info ADD Ssl_crlpath TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The path used for Certif"
  "icate Revocation List (CRL) files';\n",
"ALTER TABLE slave_master_info STATS_PERSISTENT=0;\n",
"ALTER TABLE slave_worker_info STATS_PERSISTENT=0;\n",
"ALTER TABLE slave_relay_log_info STATS_PERSISTENT=0;\n",
"ALTER TABLE gtid_executed STATS_PERSISTENT=0;\n",
"ALTER TABLE slave_master_info\n"
  "  ADD Channel_name CHAR(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT 'The channel on wh"
  "ich the slave is connected to a source. Used in Multisource Replication',\n"
  "  DROP PRIMARY KEY,\n"
  "  ADD PRIMARY KEY(Channel_name);\n",
"ALTER TABLE slave_relay_log_info\n"
  "  ADD Channel_name CHAR(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT 'The channel on wh"
  "ich the slave is connected to a source. Used in Multisource Replication',\n"
  "  DROP PRIMARY KEY,\n"
  "  ADD PRIMARY KEY(Channel_name);\n",
"ALTER TABLE slave_worker_info\n"
  "  ADD Channel_name CHAR(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT 'The channel on wh"
  "ich the slave is connected to a source. Used in Multisource Replication',\n"
  "  DROP PRIMARY KEY,\n"
  "  ADD PRIMARY KEY(Channel_name, Id);\n",
"ALTER TABLE slave_master_info ADD Tls_version TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'Tls version';\n",
"ALTER TABLE slave_master_info\n"
  "  MODIFY COLUMN Tls_version TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'Tls version'\n"
  "  AFTER Channel_name;\n",
"ALTER TABLE slave_master_info ADD Public_key_path TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The file containing "
  "public key of master server.';\n",
"ALTER TABLE slave_master_info ADD Get_public_key BOOLEAN NOT NULL COMMENT 'Preference to get public key from master.';\n",
"ALTER TABLE slave_master_info ADD Network_namespace TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'Network namespace "
  "used for communication with the master server.';\n",
"ALTER TABLE slave_master_info\n"
  "  MODIFY COLUMN Public_key_path TEXT CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The file containing public key of m"
  "aster server.'\n"
  "  AFTER Tls_version;\n",
"ALTER TABLE slave_master_info\n"
  "  MODIFY COLUMN Get_public_key BOOLEAN NOT NULL COMMENT 'Preference to get public key from master.'\n"
  "  AFTER Public_key_path;\n",
"ALTER TABLE slave_master_info\n"
  "  MODIFY COLUMN Network_namespace TEXT CHARACTER SET utf8 COLLATE utf8_bin\n"
  "  COMMENT 'Network namespace used for communication with the master server.'\n"
  "  AFTER Get_public_key;\n",
"DROP function  IF EXISTS mysql.mysql_cluster_privileges_are_distributed;\n",
"DROP procedure IF EXISTS mysql.mysql_cluster_backup_privileges;\n",
"DROP procedure IF EXISTS mysql.mysql_cluster_move_grant_tables;\n",
"DROP procedure IF EXISTS mysql.mysql_cluster_restore_local_privileges;\n",
"DROP procedure IF EXISTS mysql.mysql_cluster_restore_privileges;\n",
"DROP procedure IF EXISTS mysql.mysql_cluster_restore_privileges_from_local;\n",
"DROP procedure IF EXISTS mysql.mysql_cluster_move_privileges;\n",
"SET @cmd=\"ALTER TABLE ndb_binlog_index\n"
  "  ADD COLUMN next_position BIGINT UNSIGNED NOT NULL\";\n",
"SET @str = IF(@have_ndb_binlog_index = 1, @cmd, 'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE ndb_binlog_index\n"
  "  ADD COLUMN next_file VARCHAR(255) NOT NULL\";\n",
"SET @str = IF(@have_ndb_binlog_index = 1, @cmd, 'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE ndb_binlog_index\n"
  "  ENGINE=InnoDB STATS_PERSISTENT=0\";\n",
"SET @str = IF(@have_ndb_binlog_index = 1, @cmd, 'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @global_automatic_sp_privileges = @@GLOBAL.automatic_sp_privileges;\n",
"SET GLOBAL automatic_sp_privileges = FALSE;\n",
"DROP PROCEDURE IF EXISTS mysql.warn_host_table_nonempty;\n",
"CREATE PROCEDURE mysql.warn_host_table_nonempty() SIGNAL SQLSTATE '01000' SET MESSAGE_TEXT='Table mysql.host is not empt"
  "y. It is deprecated and will be removed in a future release.';\n",
"SET @cmd='call mysql.warn_host_table_nonempty()';\n",
"SET @have_host_table=0;\n",
"SET @host_table_nonempty=0;\n",
"SET @have_host_table=(SELECT COUNT(*) FROM information_schema.tables WHERE table_name LIKE 'host' AND table_schema LIKE "
  "'mysql' AND table_type LIKE 'BASE TABLE');\n",
"SET @host_table_nonempty_str=IF(@have_host_table > 0, 'SET @host_table_nonempty=(SELECT COUNT(*) FROM mysql.host)', 'SET"
  " @dummy=0');\n",
"PREPARE stmt FROM @host_table_nonempty_str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @str=IF(@host_table_nonempty > 0, @cmd, 'SET @dummy=0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"SHOW WARNINGS;\n",
"DROP PREPARE stmt;\n",
"DROP PROCEDURE mysql.warn_host_table_nonempty;\n",
"SET GLOBAL automatic_sp_privileges = @global_automatic_sp_privileges;\n",
"ALTER TABLE help_category MODIFY url TEXT NOT NULL;\n",
"ALTER TABLE help_topic MODIFY url TEXT NOT NULL;\n",
"ALTER TABLE func ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE help_topic ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE help_category ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE help_relation ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE help_keyword ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE plugin ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE servers ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE time_zone ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE time_zone_leap_second ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE time_zone_name ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE time_zone_transition ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE time_zone_transition_type ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE db ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE user ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE tables_priv ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE columns_priv ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE procs_priv ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE proxies_priv ENGINE=InnoDB STATS_PERSISTENT=0;\n",
"ALTER TABLE user ADD Create_role_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER account_locked;\n",
"ALTER TABLE user MODIFY Create_role_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER account_locked"
  ";\n",
"ALTER TABLE user ADD Drop_role_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Create_role_priv;\n",
"ALTER TABLE user MODIFY Drop_role_priv enum('N','Y') COLLATE utf8_general_ci DEFAULT 'N' NOT NULL AFTER Create_role_priv"
  ";\n",
"UPDATE user SET Create_role_priv= 'Y', Drop_role_priv= 'Y' WHERE Create_user_priv = 'Y';\n",
"ALTER TABLE user ADD Password_reuse_history smallint unsigned NULL DEFAULT NULL AFTER Drop_role_priv;\n",
"ALTER TABLE user ADD Password_reuse_time smallint unsigned NULL DEFAULT NULL AFTER Password_reuse_history;\n",
"ALTER TABLE user ADD Password_require_current enum('N', 'Y') COLLATE utf8_general_ci DEFAULT NULL AFTER Password_reuse_t"
  "ime;\n",
"ALTER TABLE user MODIFY Password_require_current enum('N','Y') COLLATE utf8_general_ci DEFAULT NULL AFTER Password_reuse"
  "_time;\n",
"ALTER TABLE user ADD User_attributes JSON DEFAULT NULL AFTER Password_require_current;\n",
"SET @had_firewall_whitelist =\n"
  "  (SELECT COUNT(table_name) FROM information_schema.tables\n"
  "     WHERE table_schema = 'mysql' AND table_name = 'firewall_whitelist' AND\n"
  "           table_type = 'BASE TABLE');\n",
"SET @cmd=\"ALTER TABLE mysql.firewall_whitelist ENGINE=InnoDB\";\n",
"SET @str = IF(@had_firewall_whitelist > 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE mysql.firewall_whitelist \"\n"
  "         \"MODIFY COLUMN USERHOST VARCHAR(288) NOT NULL\";\n",
"SET @str = IF(@had_firewall_whitelist > 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @had_firewall_users =\n"
  "  (SELECT COUNT(table_name) FROM information_schema.tables\n"
  "     WHERE table_schema = 'mysql' AND table_name = 'firewall_users' AND\n"
  "           table_type = 'BASE TABLE');\n",
"SET @cmd=\"ALTER TABLE mysql.firewall_users ENGINE=InnoDB\";\n",
"SET @str = IF(@had_firewall_users > 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE mysql.firewall_users \"\n"
  "         \"MODIFY COLUMN USERHOST VARCHAR(288)\";\n",
"SET @str = IF(@had_firewall_users > 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @firewall_whitelist_id_column =\n"
  "  (SELECT COUNT(column_name) FROM information_schema.columns\n"
  "     WHERE table_schema = 'mysql' AND table_name = 'firewall_whitelist' AND column_name = 'ID');\n",
"SET @cmd=\"ALTER TABLE mysql.firewall_whitelist ADD ID INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY\";\n",
"SET @str = IF(@had_firewall_whitelist > 0 AND @firewall_whitelist_id_column = 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @had_audit_log_user =\n"
  "  (SELECT COUNT(table_name) FROM information_schema.tables\n"
  "     WHERE table_schema = 'mysql' AND table_name = 'audit_log_user' AND\n"
  "           table_type = 'BASE TABLE');\n",
"SET @cmd=\"ALTER TABLE mysql.audit_log_user DROP FOREIGN KEY audit_log_user_ibfk_1\";\n",
"SET @str = IF(@had_audit_log_user > 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE mysql.audit_log_user MODIFY COLUMN HOST VARCHAR(255) BINARY NOT NULL\";\n",
"SET @str = IF(@had_audit_log_user > 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @had_audit_log_filter =\n"
  "  (SELECT COUNT(table_name) FROM information_schema.tables\n"
  "     WHERE table_schema = 'mysql' AND table_name = 'audit_log_filter' AND\n"
  "           table_type = 'BASE TABLE');\n",
"SET @cmd=\"ALTER TABLE mysql.audit_log_filter ENGINE=InnoDB\";\n",
"SET @str = IF(@had_audit_log_filter > 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE mysql.audit_log_filter CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_as_ci\";\n",
"SET @str = IF(@had_audit_log_filter > 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @had_audit_log_user =\n"
  "  (SELECT COUNT(table_name) FROM information_schema.tables\n"
  "     WHERE table_schema = 'mysql' AND table_name = 'audit_log_user' AND\n"
  "           table_type = 'BASE TABLE');\n",
"SET @cmd=\"ALTER TABLE mysql.audit_log_user ENGINE=InnoDB\";\n",
"SET @str = IF(@had_audit_log_user > 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE mysql.audit_log_user CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_as_ci\";\n",
"SET @str = IF(@had_audit_log_user > 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE mysql.audit_log_user MODIFY COLUMN USER VARCHAR(32)\";\n",
"SET @str = IF(@had_audit_log_user > 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE mysql.audit_log_user ADD FOREIGN KEY (FILTERNAME) REFERENCES mysql.audit_log_filter(NAME)\";\n",
"SET @str = IF(@had_audit_log_user > 0, @cmd, \"SET @dummy = 0\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @have_server_cost_default =\n"
  "  (SELECT COUNT(column_name) FROM information_schema.columns\n"
  "     WHERE table_schema = 'mysql' AND table_name = 'server_cost' AND\n"
  "           column_name = 'default_value');\n",
"SET @op = IF(@have_server_cost_default > 0, \"MODIFY COLUMN \", \"ADD COLUMN \");\n",
"SET @str = CONCAT(\"ALTER TABLE mysql.server_cost \", @op,\n"
  "   \"default_value FLOAT GENERATED ALWAYS AS\n"
  "    (CASE cost_name\n"
  "       WHEN 'disk_temptable_create_cost' THEN 20.0\n"
  "       WHEN 'disk_temptable_row_cost' THEN 0.5\n"
  "       WHEN 'key_compare_cost' THEN 0.05\n"
  "       WHEN 'memory_temptable_create_cost' THEN 1.0\n"
  "       WHEN 'memory_temptable_row_cost' THEN 0.1\n"
  "       WHEN 'row_evaluate_cost' THEN 0.1\n"
  "       ELSE NULL\n"
  "     END) VIRTUAL\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @have_engine_cost_default =\n"
  "  (SELECT COUNT(column_name) FROM information_schema.columns\n"
  "     WHERE table_schema = 'mysql' AND table_name = 'engine_cost' AND\n"
  "           column_name = 'default_value');\n",
"SET @op = IF(@have_engine_cost_default > 0, \"MODIFY COLUMN \", \"ADD COLUMN \");\n",
"SET @str = CONCAT(\"ALTER TABLE mysql.engine_cost \", @op,\n"
  "   \"default_value FLOAT GENERATED ALWAYS AS\n"
  "    (CASE cost_name\n"
  "       WHEN 'io_block_read_cost' THEN 1.0\n"
  "       WHEN 'memory_block_read_cost' THEN 0.25\n"
  "       ELSE NULL\n"
  "     END) VIRTUAL\");\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"INSERT IGNORE INTO mysql.user VALUES ('localhost','mysql.session','N','N','N','N','N','N','N','Y','N','N','N','N','N','N"
  "','N','Y','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'caching_sha2_password','$A$005$THI"
  "SISACOMBINATIONOFINVALIDSALTANDPASSWORDTHATMUSTNEVERBRBEUSED','N',CURRENT_TIMESTAMP,NULL,'Y', 'N', 'N', NULL, NULL, N"
  "ULL, NULL);\n",
"UPDATE user SET Create_role_priv= 'N', Drop_role_priv= 'N' WHERE User= 'mysql.session';\n",
"UPDATE user SET Shutdown_priv= 'Y' WHERE User= 'mysql.session';\n",
"INSERT IGNORE INTO mysql.tables_priv VALUES ('localhost', 'mysql', 'mysql.session', 'user', 'root\\@localhost', CURRENT_T"
  "IMESTAMP, 'Select', '');\n",
"INSERT IGNORE INTO mysql.db VALUES ('localhost', 'performance_schema', 'mysql.session','Y','N','N','N','N','N','N','N','"
  "N','N','N','N','N','N','N','N','N','N','N');\n",
"INSERT IGNORE INTO mysql.global_grants VALUES ('mysql.session', 'localhost', 'PERSIST_RO_VARIABLES_ADMIN', 'N');\n",
"INSERT IGNORE INTO mysql.global_grants VALUES ('mysql.session', 'localhost', 'SYSTEM_VARIABLES_ADMIN', 'N');\n",
"INSERT IGNORE INTO mysql.global_grants VALUES ('mysql.session', 'localhost', 'SESSION_VARIABLES_ADMIN', 'N');\n",
"INSERT IGNORE INTO mysql.global_grants VALUES ('mysql.session', 'localhost', 'BACKUP_ADMIN', 'N');\n",
"INSERT IGNORE INTO mysql.global_grants VALUES ('mysql.session', 'localhost', 'CLONE_ADMIN', 'N');\n",
"INSERT IGNORE INTO mysql.global_grants VALUES ('mysql.session', 'localhost', 'SYSTEM_USER', 'N');\n",
"SET @cmd=\"ALTER TABLE mysql.db TABLESPACE = mysql\";\n",
"PREPARE stmt FROM @cmd;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE mysql.user TABLESPACE = mysql\";\n",
"PREPARE stmt FROM @cmd;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE mysql.tables_priv TABLESPACE = mysql\";\n",
"PREPARE stmt FROM @cmd;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE mysql.columns_priv TABLESPACE = mysql\";\n",
"PREPARE stmt FROM @cmd;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE mysql.procs_priv TABLESPACE = mysql\";\n",
"PREPARE stmt FROM @cmd;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE mysql.proxies_priv TABLESPACE = mysql\";\n",
"PREPARE stmt FROM @cmd;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"SET @cmd=\"ALTER TABLE ndb_binlog_index TABLESPACE = mysql\";\n",
"SET @str = IF(@have_ndb_binlog_index = 1, @cmd, 'SET @dummy = 0');\n",
"PREPARE stmt FROM @str;\n",
"EXECUTE stmt;\n",
"DROP PREPARE stmt;\n",
"ALTER TABLE mysql.func TABLESPACE = mysql;\n",
"ALTER TABLE mysql.plugin TABLESPACE = mysql;\n",
"ALTER TABLE mysql.servers TABLESPACE = mysql;\n",
"ALTER TABLE mysql.help_topic TABLESPACE = mysql;\n",
"ALTER TABLE mysql.help_category TABLESPACE = mysql;\n",
"ALTER TABLE mysql.help_relation TABLESPACE = mysql;\n",
"ALTER TABLE mysql.help_keyword TABLESPACE = mysql;\n",
"ALTER TABLE mysql.time_zone_name TABLESPACE = mysql;\n",
"ALTER TABLE mysql.time_zone TABLESPACE = mysql;\n",
"ALTER TABLE mysql.time_zone_transition TABLESPACE = mysql;\n",
"ALTER TABLE mysql.time_zone_transition_type TABLESPACE = mysql;\n",
"ALTER TABLE mysql.time_zone_leap_second TABLESPACE = mysql;\n",
"ALTER TABLE mysql.slave_relay_log_info TABLESPACE = mysql;\n",
"ALTER TABLE mysql.slave_master_info TABLESPACE = mysql;\n",
"ALTER TABLE mysql.slave_worker_info TABLESPACE = mysql;\n",
"ALTER TABLE mysql.gtid_executed TABLESPACE = mysql;\n",
"ALTER TABLE mysql.server_cost TABLESPACE = mysql;\n",
"ALTER TABLE mysql.engine_cost TABLESPACE = mysql;\n",
"ALTER TABLE db\n"
  "  MODIFY Host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL;\n",
"ALTER TABLE user\n"
  "  MODIFY Host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL;\n",
"ALTER TABLE default_roles\n"
  "MODIFY HOST CHAR(255) CHARACTER SET ASCII DEFAULT '' NOT NULL,\n"
  "MODIFY DEFAULT_ROLE_HOST CHAR(255) CHARACTER SET ASCII DEFAULT '%' NOT NULL;\n",
"ALTER TABLE role_edges\n"
  "MODIFY FROM_HOST CHAR(255) CHARACTER SET ASCII DEFAULT '' NOT NULL,\n"
  "MODIFY TO_HOST CHAR(255) CHARACTER SET ASCII DEFAULT '' NOT NULL;\n",
"ALTER TABLE global_grants\n"
  "MODIFY HOST CHAR(255) CHARACTER SET ASCII DEFAULT '' NOT NULL;\n",
"ALTER TABLE password_history\n"
  "MODIFY Host CHAR(255) CHARACTER SET ASCII DEFAULT '' NOT NULL;\n",
"ALTER TABLE servers\n"
  "MODIFY Host char(255) CHARACTER SET ASCII NOT NULL DEFAULT '';\n",
"ALTER TABLE tables_priv\n"
  "MODIFY Host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL,\n"
  "MODIFY Grantor varchar(288) binary DEFAULT '' NOT NULL;\n",
"ALTER TABLE columns_priv\n"
  "MODIFY Host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL;\n",
"ALTER TABLE slave_master_info\n"
  "MODIFY Host CHAR(255) CHARACTER SET ASCII COMMENT 'The host name of the master.';\n",
"ALTER TABLE procs_priv\n"
  "MODIFY Host char(255) CHARACTER SET ASCII DEFAULT '' NOT NULL,\n"
  "MODIFY Grantor varchar(288) binary DEFAULT '' NOT NULL;\n",
"ALTER TABLE columns_priv ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE db ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE default_roles ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE engine_cost ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE func ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE global_grants ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE gtid_executed ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE help_category ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE help_keyword ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE help_relation ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE help_topic ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE plugin ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE password_history ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE procs_priv ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE proxies_priv ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE role_edges ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE servers ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE server_cost ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE slave_master_info ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE slave_worker_info ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE slave_relay_log_info ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE tables_priv ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE time_zone ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE time_zone_name ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE time_zone_leap_second ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE time_zone_transition ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE time_zone_transition_type ROW_FORMAT=DYNAMIC;\n",
"ALTER TABLE user ROW_FORMAT=DYNAMIC;\n",
"SET @@session.sql_mode = @old_sql_mode;\n",
NULL
};
