/*
 * Copyright (c) 2015, 2018, Oracle and/or its affiliates. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License, version 2.0,
 * as published by the Free Software Foundation.
 *
 * This program is also distributed with certain software (including
 * but not limited to OpenSSL) that is licensed under separate terms,
 * as designated in a particular file or component or in included license
 * documentation.  The authors of MySQL hereby grant you an additional
 * permission to link the program and your derivative works with the
 * separately licensed software that they have included with MySQL.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License, version 2.0, for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
 */

#ifndef PLUGIN_X_TESTS_DRIVER_PROCESSOR_COMMANDS_MYSQLXTEST_ERROR_NAMES_H_
#define PLUGIN_X_TESTS_DRIVER_PROCESSOR_COMMANDS_MYSQLXTEST_ERROR_NAMES_H_

#include <string>

namespace mysqlxtest {

struct Error_entry {
  const char *name;
  int error_code;
  const char *description;
  const char *odbc_state;
  const char *jdbc_state;
  unsigned int error_index;
};

int get_error_code_by_text(const std::string &argument);
const Error_entry *get_error_entry_by_id(const int error_code);
const Error_entry *get_error_entry_by_name(const std::string &name);

}  // namespace mysqlxtest

#endif  // PLUGIN_X_TESTS_DRIVER_PROCESSOR_COMMANDS_MYSQLXTEST_ERROR_NAMES_H_
